#define __ASM__
#include <sys/syscall.h>
#include "inc/red.h"
#include "inc/lbl.h"

#define GLOB(n) .globl G(n); G(n)

        .intel_syntax noprefix

        .code16
        .data

GLOB(int10_redirector):
        cmp     ah, 0x4f
        je      L(handle_vbe_mode_set)

        test    ah, ah
        jnz     L(chain_to_bios)

        pushf
        .byte   0x9a
        .word   RED_INTERRUPT_00 + 0x10
        .word   RED_SEGMENT

L(chain_to_bios):
        .byte   0xea
GLOB(bios_int10_handler):
        .long   0

L(handle_vbe_mode_set):
        .byte   0xea
        .word   RED_INTERRUPT_00 + 0x10
        .word   RED_SEGMENT
GLOB(int10_redirector_end):

        .code32
        .text

GLOB(restore_fs_gs):
        mov     fs, G(fs)
        mov     gs, G(gs)
        ret

GLOB(init):
        mov     G(es), es
        mov     G(cs), cs
        mov     G(ds), ds
        mov     G(ss), ss
        mov     G(fs), fs
        mov     G(gs), gs
        lea     eax, [esp + 4]
        mov     G(stack_top), eax
        ret

        .long   G(vbe_pm_interface_end) - G(vbe_pm_interface_tab)
GLOB(vbe_pm_interface_tab):
        .word   G(vbe_pm_interface_set_window) - G(vbe_pm_interface_tab)
        .word   G(vbe_pm_interface_set_display_start) - G(vbe_pm_interface_tab)
        .word   -1              # set palette
        .word   0               # ports and memory locations
GLOB(vbe_pm_interface_set_window):
        mov     ax, 0x4f05
        int     0x10
        ret
GLOB(vbe_pm_interface_set_display_start):
        mov     ax, 0x4f07
        int     0x10
        ret
GLOB(vbe_pm_interface_end):

        .data
        .globl  G(stack_top)
        .globl  G(stack_chunk_size)

GLOB(stack_top):
        .long   0
GLOB(stack_chunk_size):
        .long   0x1000

        .data
        .globl  G(cs)
        .globl  G(ds)
        .globl  G(es)
        .globl  G(ss)
        .globl  G(fs)
        .globl  G(gs)

G(ss):  .long 0
G(fs):  .long 0
G(gs):  .long 0
G(cs):  .long 0
G(es):  .long 0
G(ds):  .long 0

# Local Variables:
# comment-start: "#"
# End:
