#include <stdio.h>
#include <string.h>

#include <inc/int.h>
#include <inc/red.h>
#include <inc/ems.h>
#include <inc/log.h>
#include <inc/mup.h>
#include <inc/mmi.h>

#define LOG_PREFIX "EMS"
static int log_level;
static int active;

static void I67 (INT_ARGS)
{
  if (LOG_DEBUG == log_level)
    INT_log_regs (r);

  call_func (bios_emm_fn, r);
  if (AH (r)) {
    lwarn ("EMS call failed %#x\n", AH (r));
  }
}

int EMS_active ()
{
  return active;
}

void EMS_pre_init ()
{
  static struct MUP_key keys[] = {
    {"ems.active", TAG_INT, {.ip = &active}},
  };

  MUP_add_keys (keys, LENOFA (keys));
}

void EMS_init ()
{
  log_level = MUP_get_log_level ("ems");

  if (active) {
    us seg, off;

    dbg_fd = stderr;
    if (LOG_DEBUG == log_level)
      key_debug_level = 2;

    seg = RED_SEGMENT + (RED_EMS_SEGMENT >> 4);
    off = 0;
    *(ub *) RED_FLAT (RED_EMS_JUMP) = 0xea;
    *(us *) RED_FLAT (RED_EMS_JUMP + 1) = RED_INTERRUPT_00 + 0x67;
    *(us *) RED_FLAT (RED_EMS_JUMP + 3) = RED_SEGMENT;

    strcpy ((void *) RED_FLAT (RED_EMS_NAME), "EMMXXXX0");
    INT_set (0x67, I67);
    INT_set_rm (0x67, seg, off);
  }
}
