#include <inc/mem.h>
#include <inc/int.h>
#include <inc/mup.h>
#include <inc/log.h>

#define LOG_PREFIX "I15"
static int log_level = -1;

void I15 (INT_ARGS)
{
  if (-1 == log_level)
    log_level = MUP_get_log_level ("i15");

  switch (AH (r)) {
    case 0x88:
      SET_AX (r, 0);
      CLR_CF (r);
      break;

    default:
      lwarn ("unknown function %#x\n", AH (r));
      if (LOG_DEBUG == log_level) {
        INT_log_regs (r);
      }
      break;
  }
}
