#include <stdlib.h>

#include <inc/int.h>
#include <inc/kbd.h>
#include <inc/mem.h>
#include <inc/log.h>
#include <inc/mup.h>

#define LOG_PREFIX "I16"
static int log_level = -2;

void I16 (INT_ARGS)
{
  us key;

  if (-2 == log_level)
    log_level = MUP_get_log_level ("i16");

  if (log_level < LOG_DEBUG)
    linfo ("ax = %#06x\n", AX (r));
  else {
    ldebug ("ax = %#06x ", AX (r));
    INT_log_regs (r);
  }

  switch (AH (r)) {
    case 0x00:
    {
      key = KBD_get_key ();
      SET_AX (r, key);
      break;
    }

    case 0x03:
      lwarn ("U KEYBOARD - SET TYPEMATIC RATE AND DELAY\n");
      break;

    case 0x10:
    {
      do {
        key = KBD_get_key ();
      } while (0 == key);

      ldebug ("got key %#x\n", key);
      SET_AX (r, key);
      break;
    }

    case 0x01:

    case 0x11:
      key = KBD_check_key ();
      if (0 == key) {
        SET_ZF (r);
      } else {
        CLR_ZF (r);
        SET_AX (r, key);
      }
      break;

    case 0x02:
      SET_AL (r, MEM_KBD_STATUS1);
      break;

    case 0x12:
      SET_AL (r, MEM_KBD_STATUS1);
      SET_AH (r, MEM_KBD_STATUS2);
      break;

    default:
      UNHANDLED_INT (r);
      break;
  };
}
