#define HAVE_GNU_EXTENDED_ASM
#ifdef HAVE_GNU_EXTENDED_ASM
#define U_OP_BYTE(m,_r1,_w1,_wF)                \
  __asm__  (                                    \
    #m "b %0; pushfl; popl %1"                  \
    : "=q" (_w1), "=g" (_wF)                    \
    : "0" (_r1)                                 \
    : "cc")

#define S_OP_CARRY_BYTE(m,_r1,_r2,_w1,_carry,_wF)       \
  __asm__  (                                            \
    "shrl %2;" #m "b %%cl, %0; pushfl; popl %1"         \
    : "=q" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "c" (_r2), "0" (_r1)              \
    : "cc")

#define S_OP_BYTE(m,_r1,_r2,_w1,_wF)            \
  __asm__  (                                    \
    #m "b %%cl, %0; pushfl; popl %1"            \
    : "=q" (_w1), "=g" (_wF)                    \
    : "c" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_CARRY_BYTE(m,_r1,_r2,_w1,_carry,_wF)       \
  __asm__  (                                            \
    "shrl %2;" #m "b %3, %0; pushfl; popl %1"           \
    : "=q" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "q" (_r2), "0" (_r1)              \
    : "cc")

#define B_OP_BYTE(m,_r1,_r2,_w1,_wF)            \
  __asm__  (                                    \
    #m "b %2, %0; pushfl; popl %1"              \
    : "=q" (_w1), "=g" (_wF)                    \
    : "q" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_NO_RESULT_BYTE(m,_r1,_r2,_wF)      \
  __asm__  (                                    \
    #m "b %2, %1; pushfl; popl %0"              \
    : "=g" (_wF)                                \
    : "q" ((BYTE)(_r1+0)), "q" (_r2)            \
    : "cc")

/* W */
#define U_OP_WORD(m,_r1,_w1,_wF)                \
  __asm__  (                                    \
    #m "w %0; pushfl; popl %1"                  \
    : "=g" (_w1), "=g" (_wF)                    \
    : "0" (_r1)                                 \
    : "cc")

#define S_OP_CARRY_WORD(m,_r1,_r2,_w1,_carry,_wF)       \
  __asm__  (                                            \
    "shrl %2;" #m "w %%cl, %0; pushfl; popl %1"         \
    : "=g" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "c" (_r2), "0" (_r1)              \
    : "cc")

#define S_OP_WORD(m,_r1,_r2,_w1,_wF)            \
  __asm__  (                                    \
    #m "w %%cl, %0; pushfl; popl %1"            \
    : "=g" (_w1), "=g" (_wF)                    \
    : "c" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_CARRY_WORD(m,_r1,_r2,_w1,_carry,_wF)       \
  __asm__  (                                            \
    "shrl %2;" #m "w %3, %0; pushfl; popl %1"           \
    : "=g" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "g" (_r2), "0" (_r1)              \
    : "cc")

#define B_OP_WORD(m,_r1,_r2,_w1,_wF)            \
  __asm__  (                                    \
    #m "w %2, %0; pushfl; popl %1"              \
    : "=g" (_w1), "=g" (_wF)                    \
    : "g" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_NO_RESULT_WORD(m,_r1,_r2,_wF)      \
  __asm__  (                                    \
    #m "w %2, %1; pushfl; popl %0"              \
    : "=g" (_wF)                                \
    : "r" ((WORD)(_r1+0)), "g" (_r2)            \
    : "cc")

/* D */
#define U_OP_DWORD(m,_r1,_w1,_wF)               \
  __asm__  (                                    \
    #m "l %0; pushfl; popl %1"                  \
    : "=g" (_w1), "=g" (_wF)                    \
    : "0" (_r1)                                 \
    : "cc")

#define S_OP_CARRY_DWORD(m,_r1,_r2,_w1,_carry,_wF)      \
  __asm__  (                                            \
    "shrl %2;" #m "l %%cl, %0; pushfl; popl %1"         \
    : "=g" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "c" (_r2), "0" (_r1)              \
    : "cc")

#define S_OP_DWORD(m,_r1,_r2,_w1,_wF)           \
  __asm__  (                                    \
    #m "l %%cl, %0; pushfl; popl %1"            \
    : "=g" (_w1), "=g" (_wF)                    \
    : "c" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_CARRY_DWORD(m,_r1,_r2,_w1,_carry,_wF)      \
  __asm__  (                                            \
    "shrl %2;" #m "l %3, %0; pushfl; popl %1"           \
    : "=g" (_w1), "=g" (_wF)                            \
    : "g" (_carry&1), "r" (_r2), "0" (_r1)              \
    : "cc")

#define B_OP_DWORD(m,_r1,_r2,_w1,_wF)           \
  __asm__  (                                    \
    #m "l %2, %0; pushfl; popl %1"              \
    : "=g" (_w1), "=g" (_wF)                    \
    : "r" (_r2), "0" (_r1)                      \
    : "cc")

#define B_OP_NO_RESULT_DWORD(m,_r1,_r2,_wF)     \
  __asm__  (                                    \
    #m "l %2, %1; pushfl; popl %0"              \
    : "=g" (_wF)                                \
    : "r" ((DWORD)(_r1+0)), "g" (_r2)           \
    : "cc")
#else
#error uh-oh
#endif
