#ifndef __MEM_MOO__
#define __MEM_MOO__

#include <inc/adb.h>

enum {MEM_MAP_RDONLY, MEM_MAP_WRONLY, MEM_MAP_RDWR, MEM_MAP_NONE};
#define MEM_MAP_FAILED ((void*)-1)

extern void   MEM_pre_init (void);
extern void   MEM_init (void);
extern void * MEM_video_buffer (void);
extern void   MEM_unmap_mappings_to_video (void);
extern void   MEM_map_address (int target, int addr, int size);
extern void   MEM_map_address_to_video (int addr, int off, int size);
extern void   MEM_protect_memory (int addr, int size, int mprot);
extern void * MEM_map (int size, int mprot);
extern int    MEM_ram_fd (void);
extern int    MEM_ram_size (void);

#ifndef MEM_BASE
#define MEM_BASE 0 /* 0xac000000 */
#endif

#define MEM_REAL(addr)               ((addr)+MEM_BASE)
#define MEM_USER(addr)               ((addr)-MEM_BASE)

#define MEM_KBD_STATUS1              (*(ub*)MEM_REAL(0x417))
#define MEM_KBD_STATUS2              (*(ub*)MEM_REAL(0x418))
#define MEM_KBD_STATUS3              (*(ub*)MEM_REAL(0x496))
#define MEM_KBD_NEXT_CHAR            (*(us*)MEM_REAL(0x41a))
#define MEM_KBD_FREE_SLOT            (*(us*)MEM_REAL(0x41c))
#define MEM_KBD_BUFFER               ((us*)MEM_REAL(0x41e))
#define MEM_VID_MODE                 (*(ub*)MEM_REAL(0x449))
#define MEM_VID_COLUMNS              (*(us*)MEM_REAL(0x44a))
#define MEM_VID_PAGE_SIZE            (*(us*)MEM_REAL(0x44c))
#define MEM_VID_PAGE_START           (*(us*)MEM_REAL(0x44e))
#define MEM_VID_CURSOR_POSITIONS     ((us*)MEM_REAL(0x450))
#define MEM_TMR_TICKS_SINCE_MIDNIGHT (*(ui*)MEM_REAL(0x46c))
#define MEM_KBD_BUFFER_START         (*(us*)MEM_REAL(0x480))
#define MEM_KBD_BUFFER_END           (*(us*)MEM_REAL(0x482))
#define MEM_VID_ROWS                 (*(ub*)MEM_REAL(0x484))
#define MEM_VID_CHAR_HEIGHT          (*(us*)MEM_REAL(0x485))
#define MEM_CRT_ADDR                 (*(us*)MEM_REAL(0x463))
#define MEM_TICKS                    (*(ui*)MEM_REAL(0x46c))
#define MEM_A0000                    MEM_REAL(0xa0000)
#define MEM_B0000                    MEM_REAL(0xb0000)
#define MEM_B8000                    MEM_REAL(0xb8000)
#define MEM_C0000                    MEM_REAL(0xc0000)
#define MEM_MEM_SIZE                 (*(us*)MEM_REAL(0x413))

#endif /* __MEM_MOO__ */
