#ifndef __MUP_MOO__
#define __MUP_MOO__

#include <inc/adb.h>

enum MUP_tag {
  TAG_STRING,
  TAG_INT,
  TAG_IN_INT,
  TAG_LOG_LEVEL,
  TAG_SETTER
};

union MUP_var {
  char **sp;
  int *ip;
  int ii;
  int ll;
  int (*setter) (char *);
};

struct MUP_key {
  char *name;
  enum MUP_tag tag;
  union MUP_var var;
};

struct MUP_group {
  char *prefix;
  int nkeys;
  struct MUP_key *keys;
  struct MUP_group *prev;
};

extern void   MUP_init (int argc, char **argv);
extern int    MUP_get_int (char *key);
extern char  *MUP_get_string (char *key);
extern void   MUP_add_fs_mapping (int letter, char *path);
extern char  *MUP_get_fs_mapping (int letter);
extern char   MUP_get_fs_first_available_letter (int letter_from);
extern int    MUP_get_log_level (char *key);
extern void   MUP_add_keys (struct MUP_key *keys, int nkeys);
extern void   MUP_add_group (struct MUP_group *group);

#endif /* __MUP_MOO__ */
