#ifndef __VID_MOO__
#define __VID_MOO__

#include <inc/adb.h>

typedef enum {
  VID_TYPE_VGA,
  VID_TYPE_VBE
} vidtype_e;

struct VID_mode_info {
  vidtype_e typ;
  int w, h, pitch;
  int bpp;
  int rmask, gmask, bmask, amask;
};

extern ub const VID_vga_def8x16_font[];
extern ub const VID_vga_def8x14_font[];
extern ub const VID_vga_def8x8_font[];
extern ub const VID_vga_def64_palette[];
extern ub const VID_vga_def256_palette[];

extern void VID_pre_init (void);
extern int  VID_create (struct VID_mode_info *info);
extern void VID_init (void);
extern int  VID_is_locked (void);
extern int  VID_lock (void);
extern void VID_unlock (void);
extern void VID_maybe_unlock (int was_locked);
extern void VID_set_palette (const ub *pal, int first, int ncolors);
extern void VID_run (void);
extern void VID_flip_fullscreen (void);
extern void VID_windowed (void);
extern void VID_update (void);
extern void VID_set_font (const ub *font, int from,
                          int nelems, int xres, int yres);
extern void VID_text_mode_draw (const ub *src);
extern void VID_set_title (const char *title);
#ifdef USE_HERMES
extern void VID_resize (int w, int h);
#endif
extern void VID_resize_vga (int w, int h);

#endif /* __VID_MOO__ */
