minde_path=~/rel

if [ -x $minde_path/minde.opt ]; then
    minde=$minde_path/minde.opt
elif [ -x $minde_path/minde ]; then
    minde=$minde_path/minde
else
    echo Please edit $0 specifying full path to minde
    exit 1
fi

dos4gw=/dos/c/dos4gw.exe
vars=
args=
exe=

while true; do
    case "$1" in
	*=*)
	    vars=$(cat <<EOF
$vars
$1
EOF)
	    shift;;

	"") break;;

	*)
	    if [ -z $exe ]; then
		exe=$1
	    else
		args="$args $1"
	    fi
	    shift;;
    esac
done

if [ -z $exe ]; then
    echo "Usage: minde4gw.sh [key=val ..] exe args"
    exit 1
fi

first=${exe:0:1}
if [ $first != "/" ]; then
    exe=$PWD/$exe
fi

dir=$(dirname $exe)

if [ -z $dos4gw ] || [ ! -e $dos4gw ]; then
    if [ -e $dir/dos4gw.exe ]; then
	dos4gw=$dir/dos4gw.exe
    elif [ -e $PWD/dos4gw.exe ]; then
	dos4gw=$PWD/dos4gw.exe
    fi
fi

if [ -z $dos4gw ] || [ ! -e $dos4gw ]; then
    echo "Please edit minde4gw.sh, specifying correct path to dos4gw.exe"
    exit 1
fi

drive=$(dirname $dir)
dir=$(basename $dir)
exename=$(basename $exe)

exec $minde <<EOF
C=$drive
exe=$dos4gw
dir=c:\\$dir
args=$exename$args
log.i31=none
log.i21=none
log.dpmi=none
log.i2f=none
$vars
EOF
