#ifndef __FAKE_MACH_MOO__
#define __FAKE_MACH_MOO__

typedef int boolean_t;
typedef int thread_t;

struct mach_port_s {
  void *phys;
  int mapped;
  int addr;
  int addr_size;
  int size;
};

typedef struct mach_port_s *mach_port_t;

#define FALSE 0
#define TRUE 1
#define MACH_PORT_NULL 0

struct i386_thread_state {
  int edi;
  int esi;
  int ebp;
  int esp;
  int ebx;
  int edx;
  int ecx;
  int eax;
  int gs;
  int fs;
  int ds;
  int ss;
  int cs;
  int es;
};

#define KERN_SUCCESS 1
#define mach_task_self() 0

#define vm_deallocate MMI_vm_deallocate
#define new_memory_object MMI_new_memory_object
#define mach_error MMI_mach_error
#define destroy_memory_object MMI_destroy_memory_object
#define memory_object_remap MMI_memory_object_remap
#define exit_dos MMI_exit_dos

extern void destroy_memory_object (mach_port_t object);
extern int vm_deallocate (int unused, int address, int size);
extern void memory_object_remap (mach_port_t object,
                                 int offset, int addr, int size);
extern void exit_dos (void);
extern void mach_error (char *msg, int code);
extern mach_port_t new_memory_object (int size);

#endif /* __FAKE_MACH_MOO__ */
