/*
 * Portions (C) Glenn 'Gaffer' Fidler
 *          (C) MFX
 */

#include <i86.h>
#include <stdio.h>
#include <string.h>

#include "structs.h"

/* hereafter follows "loan" from mfx */
typedef struct {
  union { unsigned int edi; unsigned short di; };
  union { unsigned int esi; unsigned short si; };
  union { unsigned int ebp; unsigned short bp; };
  unsigned int ___1;
  union { unsigned int ebx; unsigned short bx; struct { char bl, bh; }; };
  union { unsigned int edx; unsigned short dx; struct { char dl, dh; }; };
  union { unsigned int ecx; unsigned short cx; struct { char cl, ch; }; };
  union { unsigned int eax; unsigned short ax; struct { char al, ah; }; };
  unsigned short flags, es, ds, fs, gs, ip, cs, sp, ss;
} Regs;

void rmint(char intno, Regs *regs);
#pragma aux rmint="mov ax, 0x300" "xor bh, bh" "xor ecx, ecx" "int 0x31" parm [bl] [edi] modify [eax ebx ecx edx esi edi];

struct VBEINFO vbe_info;
struct MODEINFO mode_info;

main ()
{
  short real_seg;
  short real_sel;
  short flat;
  int i;
  FILE *f;
  union REGS regs;
  struct SREGS sregs;
  struct DPMIREGS dregs;
  Regs r;

  regs.w.ax = 0x0100;
  regs.w.bx = 0x0020;
  int386 (0x31, &regs, &regs);

  if (regs.x.cflag) {
    fprintf (stderr, "no mem\n");
    return 1;
  }

  real_seg = regs.w.ax;
  real_sel = regs.w.dx;

  printf ("real seg, sel %#x %#x\n",
          real_seg, real_sel);

  vbe_info.VESASignature[0] = 'V';
  vbe_info.VESASignature[1] = 'B';
  vbe_info.VESASignature[2] = 'E';
  vbe_info.VESASignature[3] = '2';

  memcpy ((void *) (real_seg << 4), &vbe_info, sizeof (vbe_info));
  memset (&r, 0, sizeof(r));
  r.ax=0x4f00;
  r.di=0;
  r.es=real_seg;
  rmint(0x10, &r);
  if (0x4f != r.ax) {
    fprintf (stderr, "get info failed %#x\n", r.ax);
    return 0;
  }

  memcpy (&vbe_info, (void *) (real_seg << 4), sizeof (vbe_info));

  f = fopen ("info.vbe", "wb");
  fwrite (&vbe_info, sizeof (vbe_info), 1, f);
  fclose (f);

  f = fopen ("modes.vbe", "wb");

  for (i = 0; i < 0x200; i++) {
    memset(&r, 0, sizeof(r));
    r.ax=0x4f01;
    r.cx=i;
    r.di=0;
    r.es=real_seg;
    rmint(0x10, &r);

    if (r.ax!=0x4f) {
      int n = -1;
      printf ("no mode %#x\n", i);
      fwrite (&n, 4, 1, f);
    } else {
      printf ("got mode %#x\n", i);
      fwrite (&i, 4, 1, f);
      fwrite ((void *) (real_seg << 4), sizeof (mode_info), 1, f);
    }
  }
  fclose (f);
  return 0;
}
