#pragma pack (1)

/* structures taken almost verbatim from PTC */
struct VBEINFO
{
  char    VESASignature[4];         // 'VESA' 4 byte signature
  short   Version;                  // VBE version number
  long    OemStringPtr;             // Pointer to OEM string
  long    Capabilities;             // Capabilities of video card
  long    VideoModePtr;             // Pointer to supported modes
  short   TotalMemory;              // Number of 64kb memory blocks
  // VBE 2.0 extensions
  short   OemSoftwareRev;           // OEM Software revision number
  long    OemVendorNamePtr;         // Pointer to Vendor Name string
  long    OemProductNamePtr;        // Pointer to Product Name string
  long    OemProductRevPtr;         // Pointer to Product Revision str
  char    reserved[222];            // Pad to 256 byte block size
  char    OemDATA[256];             // Scratch pad for OEM data
};

// VESA mode information block
struct MODEINFO
{
  short   ModeAttributes;           // Mode attributes
  char    WinAAttributes;           // Window A attributes
  char    WinBAttributes;           // Window B attributes
  short   WinGranularity;           // Window granularity in k
  short   WinSize;                  // Window size in k
  short   WinASegment;              // Window A segment
  short   WinBSegment;              // Window B segment
  long    WinFuncPtr;               // Pointer to window function
  short   BytesPerScanLine;         // Bytes per scanline
  short   XResolution;              // Horizontal resolution
  short   YResolution;              // Vertical resolution
  char    XCharSize;                // Character cell width
  char    YCharSize;                // Character cell height
  char    NumberOfPlanes;           // Number of memory planes
  char    BitsPerPixel;             // Bits per pixel
  char    NumberOfBanks;            // Number of CGA style banks
  char    MemoryModel;              // Memory model type
  char    BankSize;                 // Size of CGA style banks
  char    NumberOfImagePages;       // Number of images pages
  char    reserved1;                // Reserved
  char    RedMaskSize;              // Size of direct color red mask
  char    RedFieldPosition;         // Bit posn of lsb of red mask
  char    GreenMaskSize;            // Size of direct color green mask
  char    GreenFieldPosition;       // Bit posn of lsb of green mask
  char    BlueMaskSize;             // Size of direct color blue mask
  char    BlueFieldPosition;        // Bit posn of lsb of blue mask
  char    AlphaMaskSize;            // Size of direct color alpha mask
  char    AlphaFieldPosition;       // Bit posn of lsb of alpha mask
  char    DirectColorModeInfo;      // Direct color mode attributes
  // VBE 2.0 extensions
  long    PhysBasePtr;              // Physical address for linear buf
  long    OffScreenMemOffset;       // Pointer to start of offscreen mem
  short   OffScreenMemSize;         // Amount of offscreen mem in 1Ks
  char    reserved2[206];           // Pad to 256 byte block size
};
enum MODEATTRIBS { ModeAvailable = 0x0001,  // Mode is available
                   ModeColor     = 0x0008,  // Mode is a color video mod
                   ModeGraphics  = 0x0010,  // Mode is a graphics mode
                   ModeNonBanked = 0x0040,  // Banked mode is not suppor
                   ModeLinear    = 0x0080}; // Linear mode supported

struct DPMIREGS
{
  unsigned int edi;
  unsigned int esi;
  unsigned int ebp;
  unsigned int reserved;
  unsigned int ebx;
  unsigned int edx;
  unsigned int ecx;
  unsigned int eax;
  unsigned short flags;
  unsigned short es;
  unsigned short ds;
  unsigned short fs;
  unsigned short gs;
  unsigned short ip;
  unsigned short cs;
  unsigned short sp;
  unsigned short ss;
};

#pragma pack ()
