#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <byteswap.h>
#include "turtle.h"
FILE *turtle_log;
#ifdef __GNUC__
  register X86 *env __asm__("esi");
  #define OP1(f) static void f(void);static void f()
  #define OP2(f) static void f(int)REGPARM(1);static void f(int opno)
  #define C1(f) f()
  #define C2(f,n) f(n)
#else
  #define OP1(f) static void f(X86*)REGPARM(1);static void f(X86*env)
  #define OP2(f) static void f(X86*,int)REGPARM(2);static void f(X86*env,int opno)
  #define C1(f) f(env)
  #define C2(f,n) f(env,n)
#endif
/* any: 0: add Eb,Gb */
OP1 (addEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_BYTE (add, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   0    add    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x1: add Ew,Gw */
/* 32: 0x1: add Ed,Gd */
OP1 (addEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_DWORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   1    add    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_WORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   1    add    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0xa: or Gb,Eb */
OP1 (orGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_BYTE (or, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   a     or    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x68: push Iw */
/* 32: 0x68: push Id */
OP1 (pushIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD r1;
        
        r1 = FETCH_DWORD (env);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  68   push       Id: in: imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        
        r1 = FETCH_WORD (env);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  68   push       Iw: in: imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x69: imul Gw,Ew,Iw */
/* 32: 0x69: imul Gd,Ed,Id */
OP1 (imulGvEvIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, wF;
        SDWORD r, l, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r = (SDWORD) READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r = (SDWORD) READ_DWORD_REG (env, rm);
        }
        
        l = (SDWORD) FETCH_DWORD (env);
        {
            SQWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  69   imul Gd,Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        DWORD rF, wF;
        SWORD r, l, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r = (SWORD) READ_WORD_REG (env, rm);
        }
        
        l = (SWORD) FETCH_WORD (env);
        {
            SDWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  69   imul Gw,Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x6a: pushw Ib */
/* 32: 0x6a: pushd Ib */
OP1 (pushIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SDWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6a   push       Ib: in: imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        SWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6a   push       Ib: in: imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x6b: imul Gw,Ew,Ib */
/* 32: 0x6b: imul Gd,Ed,Ib */
OP1 (imulGvEvIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, wF;
        SBYTE l;
        SDWORD r, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r = (SDWORD) READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r = (SDWORD) READ_DWORD_REG (env, rm);
        }
        
        l = (SBYTE) FETCH_BYTE (env);
        {
            SQWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6b   imul Gd,Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        DWORD rF, wF;
        SBYTE l;
        SWORD r, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r = (SWORD) READ_WORD_REG (env, rm);
        }
        
        l = (SBYTE) FETCH_BYTE (env);
        {
            SDWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6b   imul Gw,Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x6c: ins Xb */
OP1 (insXb)
{
    WORD rDX;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    rDX = READ_WORD_REG (env, _REG_DX);
    #define INS
    #define DSIZE 8
    
    {
        BYTE val;
        BYTE rep;
        DWORD dst_base;
    
        rep = READ_REP_PREFIX (env);
        dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    
    #undef DSIZE
    #undef INS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  6c    ins       Xb: in: f=%x DX=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
    
}
/* 16: 0x6d: ins Xw */
/* 32: 0x6d: ins Xd */
OP1 (insXv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD rDX;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        rDX = READ_WORD_REG (env, _REG_DX);
        #define INS
        #define DSIZE 32
        
        {
            DWORD val;
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef INS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6d    ins       Xd: in: f=%x DX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
        
    }
    else {
        WORD rDX;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        rDX = READ_WORD_REG (env, _REG_DX);
        #define INS
        #define DSIZE 16
        
        {
            WORD val;
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef INS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6d    ins       Xw: in: f=%x DX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
        
    }
}
/* 16: 0xb: or Gw,Ew */
/* 32: 0xb: or Gd,Ed */
OP1 (orGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_DWORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   b     or    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_WORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   b     or    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x6e: outs Yb */
OP1 (outsYb)
{
    WORD rDX;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    rDX = READ_WORD_REG (env, _REG_DX);
    #define OUTS
    #define DSIZE 8
    
    {
        BYTE val;
        BYTE rep;
        DWORD src_base;
    
        rep = READ_REP_PREFIX (env);
        src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    
    #undef DSIZE
    #undef OUTS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  6e   outs       Yb: in: f=%x DX=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
    
}
/* 16: 0x6f: outs Yw */
/* 32: 0x6f: outs Yd */
OP1 (outsYv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD rDX;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        rDX = READ_WORD_REG (env, _REG_DX);
        #define OUTS
        #define DSIZE 32
        
        {
            DWORD val;
            BYTE rep;
            DWORD src_base;
        
            rep = READ_REP_PREFIX (env);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef OUTS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6f   outs       Yd: in: f=%x DX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
        
    }
    else {
        WORD rDX;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        rDX = READ_WORD_REG (env, _REG_DX);
        #define OUTS
        #define DSIZE 16
        
        {
            WORD val;
            BYTE rep;
            DWORD src_base;
        
            rep = READ_REP_PREFIX (env);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef OUTS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  6f   outs       Yw: in: f=%x DX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rDX);
        
    }
}
/* any: 0xc: or AL,Ib */
OP1 (orALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_BYTE (or, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   c     or    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0xd: or AX,Iw */
/* 32: 0xd: or EAX,Id */
OP1 (oreAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_DWORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   d     or   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_WORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   d     or    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x84: test Eb,Gb */
OP1 (testEbGb)
{
    BYTE r1, r2, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_NO_RESULT_BYTE (test, r1, r2, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  84   test    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x85: test Ew,Gw */
/* 32: 0x85: test Ed,Gd */
OP1 (testEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_NO_RESULT_DWORD (test, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  85   test    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        BYTE modrm;
        WORD r1, r2;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_NO_RESULT_WORD (test, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  85   test    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* any: 0x86: xchg Eb,Gb */
OP1 (xchgEbGb)
{
    BYTE r1, r2, w1, w2, modrm;
    DWORD rm;
    modrm = FETCH_BYTE (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    w1 = r2;
    w2 = r1;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  86   xchg    Eb,Gb: in: r/m=%x gx[%d]=%x out: r/m=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                GET_MODRM_REG (modrm), r2,w1, GET_MODRM_REG (modrm), w2);
    
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w2);
}
/* 16: 0x87: xchg Ew,Gw */
/* 32: 0x87: xchg Ed,Gd */
OP1 (xchgEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r1, r2, w1, w2, rm;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        w1 = r2;
        w2 = r1;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  87   xchg    Ed,Gd: in: r/m=%x gx[%d]=%x out: r/m=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                    GET_MODRM_REG (modrm), r2,w1, GET_MODRM_REG (modrm), w2);
        
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w2);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1, w2;
        DWORD rm;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        w1 = r2;
        w2 = r1;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  87   xchg    Ew,Gw: in: r/m=%x gx[%d]=%x out: r/m=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                    GET_MODRM_REG (modrm), r2,w1, GET_MODRM_REG (modrm), w2);
        
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w2);
    }
}
/* any: 0x88: mov Eb,Gb */
OP1 (movEbGb)
{
    BYTE r2, w1, modrm;
    modrm = FETCH_BYTE (env);
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  88    mov    Eb,Gb: in: gx[%d]=%x out: r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,
                GET_MODRM_REG (modrm), r2,w1);
    
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x89: mov Ew,Gw */
/* 32: 0x89: mov Ed,Gd */
OP1 (movEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r2, w1;
        modrm = FETCH_BYTE (env);
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  89    mov    Ed,Gd: in: gx[%d]=%x out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    GET_MODRM_REG (modrm), r2,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r2, w1;
        modrm = FETCH_BYTE (env);
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  89    mov    Ew,Gw: in: gx[%d]=%x out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    GET_MODRM_REG (modrm), r2,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0x8a: mov Gb,Eb */
OP1 (movGbEb)
{
    BYTE r2, w1, modrm;
    modrm = FETCH_BYTE (env);
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  8a    mov    Gb,Eb: in: r/m=%x out: gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                GET_MODRM_REG (modrm), w1);
    
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x8b: mov Gw,Ew */
/* 32: 0x8b: mov Gd,Ed */
OP1 (movGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8b    mov    Gd,Ed: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8b    mov    Gw,Ew: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0xe: pushw CS */
/* 32: 0xe: pushd CS */
OP1 (pushCS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_CS);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   e   push       CS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_CS);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   e   push       CS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x8c: mov Ew,Sw */
/* 32: 0x8c: mov Ed,Sw */
OP1 (movEvSw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2;
        modrm = FETCH_BYTE (env);
        r2 = READ_SEGMENT_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            
            {
                /* HERE BE DRAGONS */
                DWORD rm;
                rm = LEA (env, modrm);
                WRITE_WORD_MEM (env, rm, r2);
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8c    mov    Ed,Sw: in: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), r2);
            
        }
        else {
            
            WRITE_DWORD_REG (env, GET_MODRM_RM (modrm), r2);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8c    mov    Ed,Sw: in: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), r2);
            
        }
        
    }
    else {
        BYTE modrm;
        WORD r2, w1;
        modrm = FETCH_BYTE (env);
        r2 = READ_SEGMENT_REG (env, GET_MODRM_REG (modrm));
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8c    mov    Ew,Sw: in: sw[%d]=%x out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    GET_MODRM_REG (modrm), r2,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x8d: lea Gw,M */
/* 32: 0x8d: lea Gd,M */
OP1 (leaGvM)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = rm;
            
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8d    lea    Gd, M: in: M=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = rm;
            
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8d    lea    Gw, M: in: M=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x8e: mov Sw,Ew */
/* 32: 0x8e: mov Sw,Ed */
OP1 (movSwEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD w1;
        modrm = FETCH_BYTE (env);
        
        if (IS_MODRM_MEM (modrm)) {
            {
                DWORD rm;
                rm = LEA (env, modrm);
                w1 = READ_WORD_MEM (env, rm);
            }
            if (_SEG_SS == GET_MODRM_REG (modrm)) {
                INHIBIT_INTERRUPTS (env);
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8e    mov    Sw,Ed: out: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), w1);
            
            
        }
        else {
            w1 = READ_WORD_REG (env, GET_MODRM_RM (modrm));
            if (_SEG_SS == GET_MODRM_REG (modrm)) {
                INHIBIT_INTERRUPTS (env);
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8e    mov    Sw,Ed: out: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), w1);
            
            
        }
        WRITE_SEGMENT_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD w1;
        modrm = FETCH_BYTE (env);
        
        if (IS_MODRM_MEM (modrm)) {
            {
                DWORD rm;
                rm = LEA (env, modrm);
                w1 = READ_WORD_MEM (env, rm);
            }
            if (_SEG_SS == GET_MODRM_REG (modrm)) {
                INHIBIT_INTERRUPTS (env);
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8e    mov    Sw,Ew: out: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), w1);
            
            
        }
        else {
            w1 = READ_WORD_REG (env, GET_MODRM_RM (modrm));
            if (_SEG_SS == GET_MODRM_REG (modrm)) {
                INHIBIT_INTERRUPTS (env);
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x  8e    mov    Sw,Ew: out: sw[%d]=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,
                        GET_MODRM_REG (modrm), w1);
            
            
        }
        WRITE_SEGMENT_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x8f: pop Ew */
/* 32: 0x8f: pop Ed */
OP1 (popEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD w1;
        modrm = FETCH_BYTE (env);
        w1 = POP_DWORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8f    pop       Ed: out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD w1;
        modrm = FETCH_BYTE (env);
        w1 = POP_WORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  8f    pop       Ew: out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0x90: nop  */
OP1 (nop)
{
    /* nop */
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  90    nop         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* 16: 0x98: cbw  */
/* 32: 0x98: cwde  */
OP1 (cbw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SWORD rAX;
        SDWORD wEAX;
        rAX = (SWORD) READ_WORD_REG (env, _REG_AX);
        wEAX = rAX;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  98    cbw         : in: AX=%x out: EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rAX,wEAX);
        
        WRITE_DWORD_REG (env, _REG_EAX, wEAX);
    }
    else {
        SBYTE rAL;
        SWORD wAX;
        rAL = (SBYTE) READ_BYTE_REG (env, _REG_AL);
        wAX = rAL;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  98    cbw         : in: AL=%x out: AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rAL,wAX);
        
        WRITE_WORD_REG (env, _REG_AX, wAX);
    }
}
/* 16: 0x99: cwd  */
/* 32: 0x99: cdq  */
OP1 (cwd)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rEAX, wEDX;
        rEAX = READ_DWORD_REG (env, _REG_EAX);
        wEDX = -((rEAX >> 31) & 1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  99    cwd         : in: EAX=%x out: EDX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rEAX,wEDX);
        
        WRITE_DWORD_REG (env, _REG_EDX, wEDX);
    }
    else {
        WORD rAX, wDX;
        rAX = READ_WORD_REG (env, _REG_AX);
        wDX = -((rAX >> 15) & 1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  99    cwd         : in: AX=%x out: DX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rAX,wDX);
        
        WRITE_WORD_REG (env, _REG_DX, wDX);
    }
}
/* 16: 0x9a: call_16 Ap */
/* 32: 0x9a: call_32 Ap */
OP1 (callAp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9a   call       Ap:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9a   call       Ap:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* any: 0x9b: wait  */
OP1 (wait)
{
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  9b   wait         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* 16: 0x9c: pushf Fw */
/* 32: 0x9c: pushf Fd */
OP1 (pushfFv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        PUSH_DWORD_FLAGS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9c  pushf       Fd:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        PUSH_WORD_FLAGS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9c  pushf       Fw:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0x9d: popf Fw */
/* 32: 0x9d: popf Fd */
OP1 (popfFv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        POP_DWORD_FLAGS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9d   popf       Fd:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        POP_WORD_FLAGS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  9d   popf       Fw:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* any: 0x9e: sahf  */
OP1 (sahf)
{
    BYTE rAH;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAH = READ_BYTE_REG (env, _REG_AH);
    wF = rF & ~ (SF | ZF | AF | PF | CF);
    wF |= rAH & (SF | ZF | AF | PF | CF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  9e   sahf         : in: f=%x AH=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAH,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* any: 0x9f: lahf  */
OP1 (lahf)
{
    BYTE wAH;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    wAH = rF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  9f   lahf         : in: f=%x out: AH=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wAH);
    
    WRITE_BYTE_REG (env, _REG_AH, wAH);
}
/* any: 0x10: adc Eb,Gb */
OP1 (adcEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_CARRY_BYTE (adc, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  10    adc    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* any: 0xa0: mov AL,Ob */
OP1 (movALOb)
{
    BYTE r2, w1;
    if (IS_ADDRESS_SIZE_32 (env)) {
        PTR addr;
        
        addr = FETCH_DWORD (env);
        r2 = READ_BYTE_MEM (env, addr);
    }
    else {
        PTR addr;
        
        addr = FETCH_WORD (env);
        r2 = READ_BYTE_MEM (env, addr);
    }
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  a0    mov    AL,Ob: in: [O]=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
    
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0xa1: mov AX,Ow */
/* 32: 0xa1: mov EAX,Od */
OP1 (moveAXOv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD r2, w1;
        if (IS_ADDRESS_SIZE_32 (env)) {
            PTR addr;
            
            addr = FETCH_DWORD (env);
            r2 = READ_DWORD_MEM (env, addr);
        }
        else {
            PTR addr;
            
            addr = FETCH_WORD (env);
            r2 = READ_DWORD_MEM (env, addr);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a1    mov   EAX,Od: in: [O]=%x out: EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r2, w1;
        if (IS_ADDRESS_SIZE_32 (env)) {
            PTR addr;
            
            addr = FETCH_DWORD (env);
            r2 = READ_WORD_MEM (env, addr);
        }
        else {
            PTR addr;
            
            addr = FETCH_WORD (env);
            r2 = READ_WORD_MEM (env, addr);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a1    mov    AX,Ow: in: [O]=%x out: AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0xa2: mov Ob,AL */
OP1 (movObAL)
{
    BYTE r2, w1;
    r2 = READ_BYTE_REG (env, _REG_AL);
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  a2    mov    Ob,AL: in: AL=%x out: [O]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
    
    if (IS_ADDRESS_SIZE_32 (env)) {
        PTR addr;
        
        addr = FETCH_DWORD (env);
        WRITE_BYTE_MEM (env, addr, w1);
    }
    else {
        PTR addr;
        
        addr = FETCH_WORD (env);
        WRITE_BYTE_MEM (env, addr, w1);
    }
}
/* 16: 0xa3: mov Ow,AX */
/* 32: 0xa3: mov Od,EAX */
OP1 (movOveAX)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD r2, w1;
        r2 = READ_DWORD_REG (env, _REG_EAX);
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a3    mov   Od,EAX: in: EAX=%x out: [O]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        if (IS_ADDRESS_SIZE_32 (env)) {
            PTR addr;
            
            addr = FETCH_DWORD (env);
            WRITE_DWORD_MEM (env, addr, w1);
        }
        else {
            PTR addr;
            
            addr = FETCH_WORD (env);
            WRITE_DWORD_MEM (env, addr, w1);
        }
    }
    else {
        WORD r2, w1;
        r2 = READ_WORD_REG (env, _REG_AX);
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a3    mov    Ow,AX: in: AX=%x out: [O]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        if (IS_ADDRESS_SIZE_32 (env)) {
            PTR addr;
            
            addr = FETCH_DWORD (env);
            WRITE_WORD_MEM (env, addr, w1);
        }
        else {
            PTR addr;
            
            addr = FETCH_WORD (env);
            WRITE_WORD_MEM (env, addr, w1);
        }
    }
}
/* any: 0xa4: movs Xb,Yb */
OP1 (movsXbYb)
{
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    #define MOVS
    #define DSIZE 8
    
    {
        BYTE src;
        BYTE rep;
        DWORD dst_base, src_base;
    
        rep = READ_REP_PREFIX (env);
        dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    
    #undef DSIZE
    #undef MOVS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  a4   movs    Xb,Yb: in: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF);
    
}
/* 16: 0xa5: movs Xw,Yw */
/* 32: 0xa5: movs Xd,Yd */
OP1 (movsXvYv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        #define MOVS
        #define DSIZE 32
        
        {
            DWORD src;
            BYTE rep;
            DWORD dst_base, src_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef MOVS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a5   movs    Xd,Yd: in: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF);
        
    }
    else {
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        #define MOVS
        #define DSIZE 16
        
        {
            WORD src;
            BYTE rep;
            DWORD dst_base, src_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef MOVS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a5   movs    Xw,Yw: in: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF);
        
    }
}
/* any: 0xa6: cmps Xb,Yb */
OP1 (cmpsXbYb)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    #define CMPS
    #define DSIZE 8
    
    {
        BYTE src, dst;
        BYTE rep;
        DWORD dst_base, src_base;
    
        rep = READ_REP_PREFIX (env);
        dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    MOVE_FLAGS_OSZAPC (wF, rF);
    #undef DSIZE
    #undef CMPS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  a6   cmps    Xb,Yb: in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0xa7: cmps Xw,Yw */
/* 32: 0xa7: cmps Xd,Yd */
OP1 (cmpsXvYv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        #define CMPS
        #define DSIZE 32
        
        {
            DWORD src, dst;
            BYTE rep;
            DWORD dst_base, src_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        MOVE_FLAGS_OSZAPC (wF, rF);
        #undef DSIZE
        #undef CMPS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a7   cmps    Xd,Yd: in: f=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        #define CMPS
        #define DSIZE 16
        
        {
            WORD src, dst;
            BYTE rep;
            DWORD dst_base, src_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
            src_base = READ_SEGMENT_BASE (env, DEFSEG (env));
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        MOVE_FLAGS_OSZAPC (wF, rF);
        #undef DSIZE
        #undef CMPS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a7   cmps    Xw,Yw: in: f=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* any: 0xa8: test AL,Ib */
OP1 (testALIb)
{
    BYTE r1, r2;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_NO_RESULT_BYTE (test, r1, r2, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  a8   test    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0xa9: test AX,Iw */
/* 32: 0xa9: test EAX,Id */
OP1 (testeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_NO_RESULT_DWORD (test, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a9   test   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,
                    wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        WORD r1, r2;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_NO_RESULT_WORD (test, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  a9   test    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,
                    wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* 16: 0x11: adc Ew,Gw */
/* 32: 0x11: adc Ed,Gd */
OP1 (adcEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_CARRY_DWORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  11    adc    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_CARRY_WORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  11    adc    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0xaa: stos Yb */
OP1 (stosYb)
{
    BYTE val;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    val = READ_BYTE_REG (env, _REG_AL);
    #define STOS
    #define DSIZE 8
    
    {
        BYTE rep;
        DWORD dst_base;
    
        rep = READ_REP_PREFIX (env);
        dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    
    #undef DSIZE
    #undef STOS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  aa   stos       Yb: in: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, val);
    
}
/* 16: 0xab: stos Yw */
/* 32: 0xab: stos Yd */
OP1 (stosYv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, val;
        rF = READ_DWORD_FLAGS (env);
        val = READ_DWORD_REG (env, _REG_EAX);
        #define STOS
        #define DSIZE 32
        
        {
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef STOS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ab   stos       Yd: in: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, val);
        
    }
    else {
        WORD val;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        val = READ_WORD_REG (env, _REG_AX);
        #define STOS
        #define DSIZE 16
        
        {
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        
        #undef DSIZE
        #undef STOS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ab   stos       Yw: in: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, val);
        
    }
}
/* any: 0xac: lods Xb */
OP1 (lodsXb)
{
    BYTE val;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    #define LODS
    #define DSIZE 8
    
    {
        BYTE rep;
    
        rep = READ_REP_PREFIX (env);
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    #undef DSIZE
    #undef LODS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  ac   lods       Xb: in: f=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,val);
    
    WRITE_BYTE_REG (env, _REG_AL, val);
}
/* 16: 0xad: lods Xw */
/* 32: 0xad: lods Xd */
OP1 (lodsXv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, val;
        rF = READ_DWORD_FLAGS (env);
        #define LODS
        #define DSIZE 32
        
        {
            BYTE rep;
        
            rep = READ_REP_PREFIX (env);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        #undef DSIZE
        #undef LODS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ad   lods       Xd: in: f=%x out: EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,val);
        
        WRITE_DWORD_REG (env, _REG_EAX, val);
    }
    else {
        WORD val;
        DWORD rF;
        rF = READ_DWORD_FLAGS (env);
        #define LODS
        #define DSIZE 16
        
        {
            BYTE rep;
        
            rep = READ_REP_PREFIX (env);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        #undef DSIZE
        #undef LODS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ad   lods       Xw: in: f=%x out: AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,val);
        
        WRITE_WORD_REG (env, _REG_AX, val);
    }
}
/* any: 0xae: scas Yb */
OP1 (scasYb)
{
    BYTE src;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    src = READ_BYTE_REG (env, _REG_AL);
    #define SCAS
    #define DSIZE 8
    
    {
        BYTE dst;
        BYTE rep;
        DWORD dst_base;
    
        rep = READ_REP_PREFIX (env);
        dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
    
        if (IS_ADDRESS_SIZE_32 (env)) {
    #define ASIZE 32
    #include "strops.h"
    #undef ASIZE
        }
        else {
    #define ASIZE 16
    #include "strops.h"
    #undef ASIZE
        }
    }
    MOVE_FLAGS_OSZAPC (wF, rF);
    
    #undef DSIZE
    #undef SCAS
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  ae   scas       Yb: in: f=%x AL=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, src,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0xaf: scas Yw */
/* 32: 0xaf: scas Yd */
OP1 (scasYv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, src, wF;
        rF = READ_DWORD_FLAGS (env);
        src = READ_DWORD_REG (env, _REG_EAX);
        #define SCAS
        #define DSIZE 32
        
        {
            DWORD dst;
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        MOVE_FLAGS_OSZAPC (wF, rF);
        
        #undef DSIZE
        #undef SCAS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  af   scas       Yd: in: f=%x EAX=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, src,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        WORD src;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        src = READ_WORD_REG (env, _REG_AX);
        #define SCAS
        #define DSIZE 16
        
        {
            WORD dst;
            BYTE rep;
            DWORD dst_base;
        
            rep = READ_REP_PREFIX (env);
            dst_base = READ_SEGMENT_BASE (env, _SEG_ES);
        
            if (IS_ADDRESS_SIZE_32 (env)) {
        #define ASIZE 32
        #include "strops.h"
        #undef ASIZE
            }
            else {
        #define ASIZE 16
        #include "strops.h"
        #undef ASIZE
            }
        }
        MOVE_FLAGS_OSZAPC (wF, rF);
        
        #undef DSIZE
        #undef SCAS
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  af   scas       Yw: in: f=%x AX=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, src,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* any: 0x12: adc Gb,Eb */
OP1 (adcGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_CARRY_BYTE (adc, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  12    adc    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x13: adc Gw,Ew */
/* 32: 0x13: adc Gd,Ed */
OP1 (adcGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_CARRY_DWORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  13    adc    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_CARRY_WORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  13    adc    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0xc2: ret_16 Iw */
/* 32: 0xc2: ret_32 Iw */
OP1 (retIw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        DWORD rESP, wESP;
        rESP = READ_DWORD_REG (env, _REG_ESP);
        
        r1 = FETCH_WORD (env);
        JUMP_NEAR_ABSOLUTE_DWORD (env, POP_DWORD (env));
        wESP = rESP + r1 + 4;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c2    ret       Iw: in: ESP=%x imm=%x out: ESP=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rESP, r1,
                    wESP);
        
        WRITE_DWORD_REG (env, _REG_ESP, wESP);
    }
    else {
        WORD rSP, r1, wSP;
        rSP = READ_WORD_REG (env, _REG_SP);
        
        r1 = FETCH_WORD (env);
        JUMP_NEAR_ABSOLUTE_WORD (env, POP_WORD (env));
        wSP = rSP + r1 + 2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c2    ret       Iw: in: SP=%x imm=%x out: SP=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rSP, r1,wSP);
        
        WRITE_WORD_REG (env, _REG_SP, wSP);
    }
}
/* 16: 0xc3: ret_16  */
/* 32: 0xc3: ret_32  */
OP1 (ret)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        JUMP_NEAR_ABSOLUTE_DWORD (env, POP_DWORD (env));
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c3    ret         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        JUMP_NEAR_ABSOLUTE_WORD (env, POP_WORD (env));
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c3    ret         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0xc4: les Gw,Mp */
/* 32: 0xc4: les Gd,Mp */
OP1 (lesGvMp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2_seg;
        DWORD r2_off, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_DWORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_ES, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c4    les    Gd,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2_off, r2_seg, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_WORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_ES, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c4    les    Gw,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0xc5: lds Gw,Mp */
/* 32: 0xc5: lds Gd,Mp */
OP1 (ldsGvMp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2_seg;
        DWORD r2_off, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_DWORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_DS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c5    lds    Gd,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2_off, r2_seg, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_WORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_DS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c5    lds    Gw,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0xc6: mov Eb,Ib */
OP1 (movEbIb)
{
    BYTE r2, w1, modrm;
    DWORD rm;
    modrm = FETCH_BYTE (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
    }
    r2 = FETCH_BYTE (env);
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  c6    mov    Eb,Ib: in: imm=%x out: r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
    
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 3 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 3 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0xc7: mov Ew,Iw */
/* 32: 0xc7: mov Ed,Id */
OP1 (movEvIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r2, w1, rm;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
        }
        r2 = FETCH_DWORD (env);
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c7    mov    Ed,Id: in: imm=%x out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 3 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 3 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r2, w1;
        DWORD rm;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
        }
        r2 = FETCH_WORD (env);
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c7    mov    Ew,Iw: in: imm=%x out: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 3 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 3 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0x2: add Gb,Eb */
OP1 (addGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_BYTE (add, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   2    add    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* any: 0x14: adc AL,Ib */
OP1 (adcALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_CARRY_BYTE (adc, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  14    adc    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0xc8: enter_16 Iw,Ib */
/* 32: 0xc8: enter_32 Iw,Ib */
OP1 (enterIwIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2;
        WORD r1;
        
        r1 = FETCH_WORD (env);
        
        r2 = FETCH_BYTE (env);
        /* quite obviously needs fixing */
        #define EBP READ_DWORD_REG (env, _REG_EBP)
        #define ESP READ_DWORD_REG (env, _REG_ESP)
        #define BP READ_WORD_REG (env, _REG_BP)
        #define SP READ_WORD_REG (env, _REG_SP)
        {
            int level;
        
            level = r2 % 32;
        
            if (IS_STACK_32 (env)) {
                DWORD FrameTemp;
        
                PUSH_DWORD (env, EBP);
                FrameTemp = ESP;
        
                while (level--) {
                    EBP -= sizeof (DWORD);
                    PUSH_DWORD (env, READ_SEG_DWORD_MEM (env, _SEG_SS, EBP));
                }
                PUSH_DWORD (env, FrameTemp);
                EBP = FrameTemp;
                ESP = EBP - r1;
            }
            else {
                WORD FrameTemp;
        
                PUSH_WORD (env, BP);
                FrameTemp = SP;
        
                while (level--) {
                    BP -= sizeof (DWORD);
                    PUSH_DWORD (env, READ_SEG_DWORD_MEM (env, _SEG_SS, BP));
                }
                PUSH_DWORD (env, FrameTemp);
                BP = FrameTemp;
                SP = BP - r1;
            }
        }
        #undef EBP
        #undef ESP
        #undef BP
        #undef SP
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c8  enter    Iw,Ib: in: imm=%x imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
    else {
        BYTE r2;
        WORD r1;
        
        r1 = FETCH_WORD (env);
        
        r2 = FETCH_BYTE (env);
        /* quite obviously needs fixing */
        #define EBP READ_DWORD_REG (env, _REG_EBP)
        #define ESP READ_DWORD_REG (env, _REG_ESP)
        #define BP READ_WORD_REG (env, _REG_BP)
        #define SP READ_WORD_REG (env, _REG_SP)
        {
            int level;
        
            level = r2 % 32;
        
            if (IS_STACK_32 (env)) {
                DWORD FrameTemp;
        
                PUSH_DWORD (env, EBP);
                FrameTemp = ESP;
        
                while (level--) {
                    EBP -= sizeof (WORD);
                    PUSH_WORD (env, READ_SEG_WORD_MEM (env, _SEG_SS, EBP));
                }
                PUSH_WORD (env, FrameTemp);
                EBP = FrameTemp;
                ESP = EBP - r1;
            }
            else {
                WORD FrameTemp;
        
                PUSH_WORD (env, BP);
                FrameTemp = SP;
        
                while (level--) {
                    BP -= sizeof (WORD);
                    PUSH_WORD (env, READ_SEG_WORD_MEM (env, _SEG_SS, BP));
                }
                PUSH_WORD (env, FrameTemp);
                BP = FrameTemp;
                SP = BP - r1;
            }
        }
        #undef EBP
        #undef ESP
        #undef BP
        #undef SP
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c8  enter    Iw,Ib: in: imm=%x imm=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
}
/* 16: 0xc9: leave_16  */
/* 32: 0xc9: leave_32  */
OP1 (leave)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        #define EBP READ_DWORD_REG (env, _REG_EBP)
        #define ESP READ_DWORD_REG (env, _REG_ESP)
        #define BP READ_WORD_REG (env, _REG_BP)
        #define SP READ_WORD_REG (env, _REG_SP)
        if (IS_STACK_32 (env)) {
            ESP = EBP;
        }
        else {
            SP = BP;
        }
        EBP = POP_DWORD (env);
        #undef EBP
        #undef ESP
        #undef BP
        #undef SP
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c9  leave         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        #define EBP READ_DWORD_REG (env, _REG_EBP)
        #define ESP READ_DWORD_REG (env, _REG_ESP)
        #define BP READ_WORD_REG (env, _REG_BP)
        #define SP READ_WORD_REG (env, _REG_SP)
        if (IS_STACK_32 (env)) {
            ESP = EBP;
        }
        else {
            SP = BP;
        }
        BP = POP_WORD (env);
        #undef EBP
        #undef ESP
        #undef BP
        #undef SP
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  c9  leave         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0xca: retf_16 Iw */
/* 32: 0xca: retf_32 Iw */
OP1 (retfIw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ca   retf       Iw:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ca   retf       Iw:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0xcb: retf_16  */
/* 32: 0xcb: retf_32  */
OP1 (retf)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  cb   retf         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  cb   retf         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* any: 0xcc: int3  */
OP1 (int3)
{
    INTERRUPT (env, 3);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  cc   int3         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0xcd: int Ib */
OP1 (intIb)
{
    BYTE r1;
    
    r1 = FETCH_BYTE (env);
    INTERRUPT (env, r1);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  cd    int       Ib: in: imm=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
    
}
/* any: 0xce: into  */
OP1 (into)
{
    INTERRUPT (env, 4);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  ce   into         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* 16: 0xcf: iret_16  */
/* 32: 0xcf: iret_32  */
OP1 (iret)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  cf   iret         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  cf   iret         :\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0x15: adc AX,Iw */
/* 32: 0x15: adc EAX,Id */
OP1 (adceAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_CARRY_DWORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  15    adc   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_CARRY_WORD (adc, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  15    adc    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0xd4: aam Ib */
OP1 (aamIb)
{
    BYTE rAL, r1, wAH, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAL = READ_BYTE_REG (env, _REG_AL);
    
    r1 = FETCH_BYTE (env);
    wF = rF;
    wAH = rAL / r1;
    wAL = rAL % r1;
    SET_SZP (wF, 0x80, wAL);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  d4    aam       Ib: in: f=%x AL=%x imm=%x out: f=%x AH=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAL, r1,wF,
                wAH, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AH, wAH);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0xd5: aad Ib */
OP1 (aadIb)
{
    BYTE rAH, rAL, r1, wAH, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAH = READ_BYTE_REG (env, _REG_AH);
    rAL = READ_BYTE_REG (env, _REG_AL);
    
    r1 = FETCH_BYTE (env);
    wF = rF;
    wAL = rAH * r1 + rAL;
    wAH = 0;
    SET_SZP (wF, 0x80, wAL);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  d5    aad       Ib: in: f=%x AH=%x AL=%x imm=%x out: f=%x AH=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAH, rAL, r1,
                wF, wAH, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AH, wAH);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0xd6: salc  */
OP1 (salc)
{
    BYTE wAL;
    DWORD rF;
    rF = READ_DWORD_FLAGS (env);
    wAL = -(rF & CF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  d6   salc         : in: f=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wAL);
    
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0xd7: xlat  */
OP1 (xlat)
{
    BYTE rAL, wAL;
    rAL = READ_BYTE_REG (env, _REG_AL);
    if (IS_ADDRESS_SIZE_32 (env)) {
        wAL = READ_BYTE_MEM (env, READ_DWORD_REG (env, _REG_EBX) + rAL);
    }
    else {
        WORD ea;
    
        ea = READ_WORD_REG (env, _REG_BX) + rAL;
        wAL = READ_BYTE_MEM (env, ea);
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  d7   xlat         : in: AL=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rAL,wAL);
    
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* 16: 0x16: pushw SS */
/* 32: 0x16: pushd SS */
OP1 (pushSS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_SS);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  16   push       SS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_SS);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  16   push       SS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0xe0: loopnew Jb */
/* 32: 0xe0: loopned Jb */
OP1 (loopneJb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF;
        SDWORD r1;
        rF = READ_DWORD_FLAGS (env);
        
        r1 = (SBYTE) FETCH_BYTE (env);
        #if 224 & 1
        #define COND (rF & ZF)
        #else
        #define COND (0 == (rF & ZF))
        #endif
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx && COND) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx && COND) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        #undef COND
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e0 loopne       Jb: in: f=%x rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1);
        
    }
    else {
        DWORD rF;
        SWORD r1;
        rF = READ_DWORD_FLAGS (env);
        
        r1 = (SBYTE) FETCH_BYTE (env);
        #if 224 & 1
        #define COND (rF & ZF)
        #else
        #define COND (0 == (rF & ZF))
        #endif
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx && COND) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx && COND) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        #undef COND
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e0 loopne       Jb: in: f=%x rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1);
        
    }
}
/* 16: 0xe1: loopew Jb */
/* 32: 0xe1: looped Jb */
OP1 (loopeJb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF;
        SDWORD r1;
        rF = READ_DWORD_FLAGS (env);
        
        r1 = (SBYTE) FETCH_BYTE (env);
        #if 225 & 1
        #define COND (rF & ZF)
        #else
        #define COND (0 == (rF & ZF))
        #endif
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx && COND) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx && COND) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        #undef COND
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e1  loope       Jb: in: f=%x rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1);
        
    }
    else {
        DWORD rF;
        SWORD r1;
        rF = READ_DWORD_FLAGS (env);
        
        r1 = (SBYTE) FETCH_BYTE (env);
        #if 225 & 1
        #define COND (rF & ZF)
        #else
        #define COND (0 == (rF & ZF))
        #endif
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx && COND) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx && COND) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        #undef COND
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e1  loope       Jb: in: f=%x rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1);
        
    }
}
/* 16: 0xe2: loopw Jb */
/* 32: 0xe2: loopd Jb */
OP1 (loopJb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SDWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e2   loop       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        SWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        if (IS_ADDRESS_SIZE_32 (env)) {
            DWORD ecx;
        
            ecx = READ_DWORD_REG (env, _REG_ECX) - 1;
            if (ecx) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_DWORD_REG (env, _REG_ECX, ecx);
        }
        else {
            WORD cx;
        
            cx = READ_WORD_REG (env, _REG_CX) - 1;
            if (cx) {
                JUMP_NEAR_RELATIVE_WORD (env, r1);
            }
            WRITE_WORD_REG (env, _REG_CX, cx);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e2   loop       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0xe3: jcxzw Jb */
/* 32: 0xe3: jcxzd Jb */
OP1 (jcxzJb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SDWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        if (IS_ADDRESS_SIZE_32 (env)) {
            if (0 == READ_DWORD_REG (env, _REG_ECX)) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
        }
        else {
            if (0 == READ_WORD_REG (env, _REG_CX)) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e3   jcxz       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        SDWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        if (IS_ADDRESS_SIZE_32 (env)) {
            if (0 == READ_DWORD_REG (env, _REG_ECX)) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
        }
        else {
            if (0 == READ_WORD_REG (env, _REG_CX)) {
                JUMP_NEAR_RELATIVE_DWORD (env, r1);
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e3   jcxz       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* any: 0xe4: in AL,Ib */
OP1 (inALIb)
{
    BYTE r2, w1;
    
    r2 = FETCH_BYTE (env);
    w1 = READ_BYTE_PORT (env, r2);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  e4     in    AL,Ib: in: imm=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
    
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0xe5: in AX,Ib */
/* 32: 0xe5: in EAX,Ib */
OP1 (ineAXIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2;
        DWORD w1;
        
        r2 = FETCH_BYTE (env);
        w1 = READ_DWORD_PORT (env, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e5     in   EAX,Ib: in: imm=%x out: EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        BYTE r2;
        WORD w1;
        
        r2 = FETCH_BYTE (env);
        w1 = READ_WORD_PORT (env, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e5     in    AX,Ib: in: imm=%x out: AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* 16: 0x17: popw SS */
/* 32: 0x17: popd SS */
OP1 (popSS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD w1;
        w1 = POP_DWORD (env);
        INHIBIT_INTERRUPTS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  17    pop       SS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_SS, w1);
    }
    else {
        WORD w1;
        w1 = POP_WORD (env);
        INHIBIT_INTERRUPTS (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  17    pop       SS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_SS, w1);
    }
}
/* any: 0xe6: out Ib,AL */
OP1 (outIbAL)
{
    BYTE r1, r2;
    
    r1 = FETCH_BYTE (env);
    r2 = READ_BYTE_REG (env, _REG_AL);
    WRITE_BYTE_PORT (env, r1, r2);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  e6    out    Ib,AL: in: imm=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
    
}
/* 16: 0xe7: out Ib,AX */
/* 32: 0xe7: out Ib,EAX */
OP1 (outIbeAX)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r1;
        DWORD r2;
        
        r1 = FETCH_BYTE (env);
        r2 = READ_DWORD_REG (env, _REG_EAX);
        WRITE_DWORD_PORT (env, r1, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e7    out   Ib,EAX: in: imm=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
    else {
        BYTE r1;
        WORD r2;
        
        r1 = FETCH_BYTE (env);
        r2 = READ_WORD_REG (env, _REG_AX);
        WRITE_WORD_PORT (env, r1, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e7    out    Ib,AX: in: imm=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
}
/* 16: 0xe8: call_16 Jw */
/* 32: 0xe8: call_32 Jd */
OP1 (callJv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD r1;
        
        r1 = FETCH_DWORD (env);
        PUSH_DWORD (env, NEXT_IP (env));
        JUMP_NEAR_RELATIVE_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e8   call       Jd: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        
        r1 = FETCH_WORD (env);
        PUSH_WORD (env, NEXT_IP (env));
        JUMP_NEAR_RELATIVE_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e8   call       Jw: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0xe9: jmp Jw */
/* 32: 0xe9: jmp Jd */
OP1 (jmpJv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SDWORD r1;
        
        r1 = (SDWORD) FETCH_DWORD (env);
        JUMP_NEAR_RELATIVE_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e9    jmp       Jd: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        SWORD r1;
        
        r1 = (SWORD) FETCH_WORD (env);
        JUMP_NEAR_RELATIVE_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  e9    jmp       Jw: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0xea: jmp Ap */
/* 32: 0xea: jmp Ap */
OP1 (jmpAp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ea    jmp       Ap:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
    else {
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ea    jmp       Ap:\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip);
        
    }
}
/* 16: 0xeb: jmpw Jb */
/* 32: 0xeb: jmpd Jb */
OP1 (jmpJb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        SDWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        JUMP_NEAR_RELATIVE_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  eb    jmp       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        SWORD r1;
        
        r1 = (SBYTE) FETCH_BYTE (env);
        JUMP_NEAR_RELATIVE_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  eb    jmp       Jb: in: rel=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* any: 0xec: in AL,DX */
OP1 (inALDX)
{
    BYTE w1;
    WORD r2;
    r2 = READ_WORD_REG (env, _REG_DX);
    w1 = READ_BYTE_PORT (env, r2);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  ec     in    AL,DX: in: DX=%x out: AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
    
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0xed: in AX,DX */
/* 32: 0xed: in EAX,DX */
OP1 (ineAXDX)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r2;
        DWORD w1;
        r2 = READ_WORD_REG (env, _REG_DX);
        w1 = READ_DWORD_PORT (env, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ed     in   EAX,DX: in: DX=%x out: EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r2, w1;
        r2 = READ_WORD_REG (env, _REG_DX);
        w1 = READ_WORD_PORT (env, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ed     in    AX,DX: in: DX=%x out: AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
        
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0xee: out DX,AL */
OP1 (outDXAL)
{
    BYTE r2;
    WORD r1;
    r1 = READ_WORD_REG (env, _REG_DX);
    r2 = READ_BYTE_REG (env, _REG_AL);
    WRITE_BYTE_PORT (env, r1, r2);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  ee    out    DX,AL: in: DX=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
    
}
/* 16: 0xef: out DX,AX */
/* 32: 0xef: out DX,EAX */
OP1 (outDXeAX)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        DWORD r2;
        r1 = READ_WORD_REG (env, _REG_DX);
        r2 = READ_DWORD_REG (env, _REG_EAX);
        WRITE_DWORD_PORT (env, r1, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ef    out   DX,EAX: in: DX=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
    else {
        WORD r1, r2;
        r1 = READ_WORD_REG (env, _REG_DX);
        r2 = READ_WORD_REG (env, _REG_AX);
        WRITE_WORD_PORT (env, r1, r2);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  ef    out    DX,AX: in: DX=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1, r2);
        
    }
}
/* any: 0x18: sbb Eb,Gb */
OP1 (sbbEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_CARRY_BYTE (sbb, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  18    sbb    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* any: 0xf1: icebp  */
OP1 (icebp)
{
    ICEBP (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  f1  icebp         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0xf4: hlt  */
OP1 (hlt)
{
    HLT (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  f4    hlt         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0xf5: cmc  */
OP1 (cmc)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    wF = (rF ^ CF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  f5    cmc         : in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* any: 0xf8: clc  */
OP1 (clc)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    wF = rF & ~ CF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  f8    clc         : in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* any: 0xf9: stc  */
OP1 (stc)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    wF = rF | CF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  f9    stc         : in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x19: sbb Ew,Gw */
/* 32: 0x19: sbb Ed,Gd */
OP1 (sbbEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_CARRY_DWORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  19    sbb    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_CARRY_WORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  19    sbb    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0xfa: cli  */
OP1 (cli)
{
       CLI (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  fa    cli         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0xfb: sti  */
OP1 (sti)
{
       STI (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  fb    sti         :\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0xfc: cld  */
OP1 (cld)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    wF = rF & ~ DF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  fc    cld         : in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* any: 0xfd: std  */
OP1 (std)
{
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    wF = rF | DF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  fd    std         : in: f=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x102: lar Gw,Ew */
/* 32: 0x102: lar Gd,Ew */
OP1 (larGvEw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        (void) r2;
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 102    lar    Gd,Ew: in: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2);
        
    }
    else {
        BYTE modrm;
        WORD r2;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        (void) r2;
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 102    lar    Gw,Ew: in: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2);
        
    }
}
/* 16: 0x103: lsl Gw,Ew */
/* 32: 0x103: lsl Gd,Ew */
OP1 (lslGvEw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        (void) r2;
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 103    lsl    Gd,Ew: in: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2);
        
    }
    else {
        BYTE modrm;
        WORD r2;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        (void) r2;
        NOT_IMPLEMENTED (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 103    lsl    Gw,Ew: in: r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2);
        
    }
}
/* any: 0x1a: sbb Gb,Eb */
OP1 (sbbGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_CARRY_BYTE (sbb, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  1a    sbb    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x1b: sbb Gw,Ew */
/* 32: 0x1b: sbb Gd,Ed */
OP1 (sbbGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_CARRY_DWORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1b    sbb    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_CARRY_WORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1b    sbb    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x1c: sbb AL,Ib */
OP1 (sbbALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_CARRY_BYTE (sbb, r1, r2, w1, rF, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  1c    sbb    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* any: 0x120: mov Rd,Cd */
OP1 (movRdCd)
{
    BYTE modrm;
    DWORD r2, w1;
    modrm = FETCH_BYTE (env);
    r2 = READ_CONTROL_REG (env, GET_MODRM_REG (modrm));
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 120    mov    Rd,Cd: in: cr%d=%x out: rd[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,
                GET_MODRM_REG (modrm), r2,GET_MODRM_REG (modrm), w1);
    
    if (IS_MODRM_MEM (modrm)) {
        EXCEPTION (env, 6, 0); return;
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);WRITE_DWORD_REG (env, rm, w1);
    }
}
/* any: 0x121: mov Rd,Dd */
OP1 (movRdDd)
{
    BYTE modrm;
    DWORD r2, w1;
    modrm = FETCH_BYTE (env);
    r2 = READ_DEBUG_REG (env, GET_MODRM_REG (modrm));
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 121    mov    Rd,Dd: in: dr%d=%x out: rd[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,
                GET_MODRM_REG (modrm), r2,GET_MODRM_REG (modrm), w1);
    
    if (IS_MODRM_MEM (modrm)) {
        EXCEPTION (env, 6, 0); return;
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);WRITE_DWORD_REG (env, rm, w1);
    }
}
/* 16: 0x1d: sbb AX,Iw */
/* 32: 0x1d: sbb EAX,Id */
OP1 (sbbeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_CARRY_DWORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1d    sbb   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_CARRY_WORD (sbb, r1, r2, w1, rF, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1d    sbb    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x122: mov Cd,Rd */
OP1 (movCdRd)
{
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 122    mov    Cd,Rd:\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0x123: mov Dd,Rd */
OP1 (movDdRd)
{
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 123    mov    Dd,Rd:\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* any: 0x124: mov Rd,Td */
OP1 (movRdTd)
{
    BYTE modrm;
    DWORD r2, w1;
    modrm = FETCH_BYTE (env);
    r2 = READ_TEST_REG (env, GET_MODRM_REG (modrm));
    w1 = r2;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 124    mov    Rd,Td: in: tr%d=%x out: rd[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,
                GET_MODRM_REG (modrm), r2,GET_MODRM_REG (modrm), w1);
    
    if (IS_MODRM_MEM (modrm)) {
        EXCEPTION (env, 6, 0); return;
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);WRITE_DWORD_REG (env, rm, w1);
    }
}
/* any: 0x126: mov Td,Rd */
OP1 (movTdRd)
{
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 126    mov    Td,Rd:\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
/* 16: 0x3: add Gw,Ew */
/* 32: 0x3: add Gd,Ed */
OP1 (addGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_DWORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   3    add    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_WORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   3    add    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1e: pushw DS */
/* 32: 0x1e: pushd DS */
OP1 (pushDS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_DS);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1e   push       DS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_DS);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1e   push       DS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x1f: popw DS */
/* 32: 0x1f: popd DS */
OP1 (popDS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD w1;
        w1 = POP_DWORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1f    pop       DS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_DS, w1);
    }
    else {
        WORD w1;
        w1 = POP_WORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  1f    pop       DS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_DS, w1);
    }
}
/* any: 0x20: and Eb,Gb */
OP1 (andEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_BYTE (and, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  20    and    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x21: and Ew,Gw */
/* 32: 0x21: and Ed,Gd */
OP1 (andEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_DWORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  21    and    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_WORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  21    and    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* any: 0x22: and Gb,Eb */
OP1 (andGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_BYTE (and, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  22    and    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x23: and Gw,Ew */
/* 32: 0x23: and Gd,Ed */
OP1 (andGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_DWORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  23    and    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_WORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  23    and    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x24: and AL,Ib */
OP1 (andALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_BYTE (and, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  24    and    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0x25: and AX,Iw */
/* 32: 0x25: and EAX,Id */
OP1 (andeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_DWORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  25    and   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_WORD (and, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  25    and    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x27: daa  */
OP1 (daa)
{
    BYTE rAL, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAL = READ_BYTE_REG (env, _REG_AL);
    wF = rF;
    wAL = rAL;
    if (((rAL & 0x0F) > 9) || (rF & AF)) {
        wAL = wAL + 6;
        wF |= AF;
    }
    else wF &= ~ AF;
    
    if ((wAL > 0x9F) || (rF & CF)) {
        wAL = wAL + 0x60;
        wF |= CF;
    }
    else wF &= ~ CF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  27    daa         : in: f=%x AL=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAL,wF, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0x4: add AL,Ib */
OP1 (addALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_BYTE (add, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   4    add    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* any: 0x28: sub Eb,Gb */
OP1 (subEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_BYTE (sub, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  28    sub    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x29: sub Ew,Gw */
/* 32: 0x29: sub Ed,Gd */
OP1 (subEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_DWORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  29    sub    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_WORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  29    sub    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x1a0: pushw FS */
/* 32: 0x1a0: pushd FS */
OP1 (pushFS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_FS);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a0   push       FS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_FS);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a0   push       FS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x1a1: popw FS */
/* 32: 0x1a1: popd FS */
OP1 (popFS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD w1;
        w1 = POP_DWORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a1    pop       FS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_FS, w1);
    }
    else {
        WORD w1;
        w1 = POP_WORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a1    pop       FS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_FS, w1);
    }
}
/* any: 0x2a: sub Gb,Eb */
OP1 (subGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_BYTE (sub, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  2a    sub    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x1a4: shld Ew,Gw,Ib */
/* 32: 0x1a4: shld Ed,Gd,Ib */
OP1 (shldEvGvIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r3, modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        
        r3 = FETCH_BYTE (env);
        {
            int count;
        
            count = r3 & 0x1f;
            wF = rF;
        
            if (count) {
                w1 = (r1 << count) | (r2 >> (32 - count));
        
                SET_CF (wF, (w1 >> (32 - count)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x80000000));
                SET_SZP (wF, 0x80000000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a4   shld Ed,Gd,Ib: in: f=%x r/m=%x gx[%d]=%x imm=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r3, modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        
        r3 = FETCH_BYTE (env);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                DWORD tmp1, tmp2;
        
                tmp1 = (r1 << 16) | r2;
                tmp2 = tmp1 << count;
                if (count > 16) {
                    tmp2 |= r2 << (count - 16);
                }
                w1 = tmp2 >> 16;
        
                SET_CF (wF, (tmp1 >> (32 - count)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x8000));
                SET_SZP (wF, 0x8000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a4   shld Ew,Gw,Ib: in: f=%x r/m=%x gx[%d]=%x imm=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x1a5: shld Ew,Gw,CL */
/* 32: 0x1a5: shld Ed,Gd,CL */
OP1 (shldEvGvCL)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r3, modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        r3 = READ_BYTE_REG (env, _REG_CL);
        {
            int count;
        
            count = r3 & 0x1f;
            wF = rF;
        
            if (count) {
                w1 = (r1 << count) | (r2 >> (32 - count));
        
                SET_CF (wF, (w1 >> (32 - count)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x80000000));
                SET_SZP (wF, 0x80000000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a5   shld Ed,Gd,CL: in: f=%x r/m=%x gx[%d]=%x CL=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r3, modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        r3 = READ_BYTE_REG (env, _REG_CL);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                DWORD tmp1, tmp2;
        
                tmp1 = (r1 << 16) | r2;
                tmp2 = tmp1 << count;
                if (count > 16) {
                    tmp2 |= r2 << (count - 16);
                }
                w1 = tmp2 >> 16;
        
                SET_CF (wF, (tmp1 >> (32 - count)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x8000));
                SET_SZP (wF, 0x8000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a5   shld Ew,Gw,CL: in: f=%x r/m=%x gx[%d]=%x CL=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x1a8: pushw GS */
/* 32: 0x1a8: pushd GS */
OP1 (pushGS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_GS);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a8   push       GS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_GS);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a8   push       GS: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* 16: 0x1a9: popw GS */
/* 32: 0x1a9: popd GS */
OP1 (popGS)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD w1;
        w1 = POP_DWORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a9    pop       GS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_GS, w1);
    }
    else {
        WORD w1;
        w1 = POP_WORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1a9    pop       GS: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_GS, w1);
    }
}
/* 16: 0x1ac: shrd Ew,Gw,Ib */
/* 32: 0x1ac: shrd Ed,Gd,Ib */
OP1 (shrdEvGvIb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r3, modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        
        r3 = FETCH_BYTE (env);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                w1 = (r2 << (32 - count)) | (r1 >> count);
                SET_CF (wF, (r1 >> (count - 1)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x80000000));
                SET_SZP (wF, 0x80000000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1ac   shrd Ed,Gd,Ib: in: f=%x r/m=%x gx[%d]=%x imm=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r3, modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        
        r3 = FETCH_BYTE (env);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                DWORD tmp1, tmp2;
        
                tmp1 = (r2 << 16) | r1;
                tmp2 = tmp1 >> count;
                if (count > 16) {
                    tmp2 |= r2 << (32 - count);
                }
                w1 = tmp2;
                SET_CF (wF, (tmp1 >> (count - 1)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x8000));
                SET_SZP (wF, 0x8000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1ac   shrd Ew,Gw,Ib: in: f=%x r/m=%x gx[%d]=%x imm=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x1ad: shrd Ew,Gw,CL */
/* 32: 0x1ad: shrd Ed,Gd,CL */
OP1 (shrdEvGvCL)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r3, modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        r3 = READ_BYTE_REG (env, _REG_CL);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                w1 = (r2 << (32 - count)) | (r1 >> count);
                SET_CF (wF, (r1 >> (count - 1)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x80000000));
                SET_SZP (wF, 0x80000000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1ad   shrd Ed,Gd,CL: in: f=%x r/m=%x gx[%d]=%x CL=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r3, modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        r3 = READ_BYTE_REG (env, _REG_CL);
        {
            int count;
        
            wF = rF;
            count = r3 & 0x1f;
        
            if (count) {
                DWORD tmp1, tmp2;
        
                tmp1 = (r2 << 16) | r1;
                tmp2 = tmp1 >> count;
                if (count > 16) {
                    tmp2 |= r2 << (32 - count);
                }
                w1 = tmp2;
                SET_CF (wF, (tmp1 >> (count - 1)) & 1);
                if (1 == count) SET_OF (wF, 0 != ((r1 ^ w1) & 0x8000));
                SET_SZP (wF, 0x8000, w1);
            }
            else {
                w1 = r1;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1ad   shrd Ew,Gw,CL: in: f=%x r/m=%x gx[%d]=%x CL=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2, r3,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x2b: sub Gw,Ew */
/* 32: 0x2b: sub Gd,Ed */
OP1 (subGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_DWORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  2b    sub    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_WORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  2b    sub    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1af: imul Gw,Ew */
/* 32: 0x1af: imul Gd,Ed */
OP1 (imulGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, wF;
        SDWORD r, l, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r = (SDWORD) READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            l = (SDWORD) READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            l = (SDWORD) READ_DWORD_REG (env, rm);
        }
        {
            SQWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1af   imul    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        DWORD rF, wF;
        SWORD r, l, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r = (SWORD) READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            l = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            l = (SWORD) READ_WORD_REG (env, rm);
        }
        {
            SDWORD tmp;
        
            tmp = r;
            tmp *= l;
            w1 = tmp;
        
            if (tmp == w1) {
                wF = rF & ~ OC;
            }
            else {
                wF = rF | OC;
            }
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1af   imul    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r, l,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x1b0: cmpxchg Eb,Gb */
OP1 (cmpxchgEbGb)
{
    BYTE rACC, r1, r2, wACC, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    rACC = READ_BYTE_REG (env, _REG_AL);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (rACC == r1) {
        wF = rF | ZF;
        w1 = r2;
        wACC = rACC;
    }
    else {
        wF = rF & ~ ZF;
        wACC = r1;
        w1 = r1;
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 1b0 cmpxchg    Eb,Gb: in: f=%x AL=%x r/m=%x gx[%d]=%x out: f=%x AL=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rACC, r1,
                GET_MODRM_REG (modrm), r2,wF, wACC, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, wACC);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x1b1: cmpxchg Ew,Gw */
/* 32: 0x1b1: cmpxchg Ed,Gd */
OP1 (cmpxchgEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, rACC, r1, r2, wF, wACC, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        rACC = READ_DWORD_REG (env, _REG_EAX);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (rACC == r1) {
            wF = rF | ZF;
            w1 = r2;
            wACC = rACC;
        }
        else {
            wF = rF & ~ ZF;
            wACC = r1;
            w1 = r1;
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b1 cmpxchg    Ed,Gd: in: f=%x EAX=%x r/m=%x gx[%d]=%x out: f=%x EAX=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rACC, r1,
                    GET_MODRM_REG (modrm), r2,wF, wACC, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, wACC);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD rACC, r1, r2, wACC, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        rACC = READ_WORD_REG (env, _REG_AX);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (rACC == r1) {
            wF = rF | ZF;
            w1 = r2;
            wACC = rACC;
        }
        else {
            wF = rF & ~ ZF;
            wACC = r1;
            w1 = r1;
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b1 cmpxchg    Ew,Gw: in: f=%x AX=%x r/m=%x gx[%d]=%x out: f=%x AX=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rACC, r1,
                    GET_MODRM_REG (modrm), r2,wF, wACC, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, wACC);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x1b2: lss Gw,Mp */
/* 32: 0x1b2: lss Gd,Mp */
OP1 (lssGvMp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2_seg;
        DWORD r2_off, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_DWORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_SS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b2    lss    Gd,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2_off, r2_seg, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_WORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_SS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b2    lss    Gw,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1b4: lfs Gw,Mp */
/* 32: 0x1b4: lfs Gd,Mp */
OP1 (lfsGvMp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2_seg;
        DWORD r2_off, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_DWORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_FS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b4    lfs    Gd,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2_off, r2_seg, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_WORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_FS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b4    lfs    Gw,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1b5: lgs Gw,Mp */
/* 32: 0x1b5: lgs Gd,Mp */
OP1 (lgsGvMp)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2_seg;
        DWORD r2_off, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_DWORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_GS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b5    lgs    Gd,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r2_off, r2_seg, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_off = READ_WORD_MEM (env, rm);
            r2_seg = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        w1 = r2_off;
        WRITE_SEGMENT_REG (env, _SEG_GS, r2_seg);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b5    lgs    Gw,Mp: in: seg:off=%x:%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    r2_seg, r2_off,GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1b6: movzx Gw,Eb */
/* 32: 0x1b6: movzx Gd,Eb */
OP1 (movzxGvEb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2, modrm;
        DWORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_BYTE_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_BYTE_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b6  movzx    Gd,Eb: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE r2, modrm;
        WORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_BYTE_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_BYTE_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b6  movzx    Gw,Eb: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1b7: movzx Gw,Ew */
/* 32: 0x1b7: movzx Gd,Ew */
OP1 (movzxGvEw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        WORD r2;
        DWORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b7  movzx    Gd,Ew: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        SWORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = (SWORD) READ_WORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1b7  movzx    Gw,Ew: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x2c: sub AL,Ib */
OP1 (subALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_BYTE (sub, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  2c    sub    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0x1be: movsx Gw,Eb */
/* 32: 0x1be: movsx Gd,Eb */
OP1 (movsxGvEb)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        SBYTE r2;
        SDWORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = (SBYTE) READ_BYTE_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = (SBYTE) READ_BYTE_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1be  movsx    Gd,Eb: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        SBYTE r2;
        SWORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = (SBYTE) READ_BYTE_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = (SBYTE) READ_BYTE_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1be  movsx    Gw,Eb: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x1bf: movsx Gw,Ew */
/* 32: 0x1bf: movsx Gd,Ew */
OP1 (movsxGvEw)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        SWORD r2;
        SDWORD w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = (SWORD) READ_WORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1bf  movsx    Gd,Ew: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        SWORD r2, w1;
        modrm = FETCH_BYTE (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = (SWORD) READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = (SWORD) READ_WORD_REG (env, rm);
        }
        w1 = r2;
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x 1bf  movsx    Gw,Ew: in: r/m=%x out: gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* 16: 0x2d: sub AX,Iw */
/* 32: 0x2d: sub EAX,Id */
OP1 (subeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_DWORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  2d    sub   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_WORD (sub, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  2d    sub    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x2f: das  */
OP1 (das)
{
    BYTE rAL, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAL = READ_BYTE_REG (env, _REG_AL);
    wF = rF;
    wAL = rAL;
    if (((rAL & 0x0F) > 9) || (rF & AF)) {
        wAL = wAL - 6;
        wF |= AF;
    }
    else wF &= ~ AF;
    
    if ((wAL > 0x9F) || (rF & CF)) {
        wAL = wAL - 0x60;
        wF |= CF;
    }
    else wF &= ~ CF;
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  2f    das         : in: f=%x AL=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAL,wF, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0x30: xor Eb,Gb */
OP1 (xorEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    /* HERE BE DRAGONS */
    if (0xc0 == modrm) {
        w1 = 0;
        wF = (ZF | PF)|(rF & ~ (OSZAPC));
    }
    else {
        B_OP_BYTE (xor, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  30    xor    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x31: xor Ew,Gw */
/* 32: 0x31: xor Ed,Gd */
OP1 (xorEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        /* HERE BE DRAGONS */
        if (0xc0 == modrm) {
            w1 = 0;
            wF = (ZF | PF)|(rF & ~ (OSZAPC));
        }
        else {
            B_OP_DWORD (xor, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  31    xor    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        /* HERE BE DRAGONS */
        if (0xc0 == modrm) {
            w1 = 0;
            wF = (ZF | PF)|(rF & ~ (OSZAPC));
        }
        else {
            B_OP_WORD (xor, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  31    xor    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x5: add AX,Iw */
/* 32: 0x5: add EAX,Id */
OP1 (addeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_DWORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   5    add   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_WORD (add, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   5    add    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x32: xor Gb,Eb */
OP1 (xorGbEb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    /* HERE BE DRAGONS */
    if (0xc0 == modrm) {
        w1 = 0;
        wF = (ZF | PF)|(rF & ~ (OSZAPC));
    }
    else {
        B_OP_BYTE (xor, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  32    xor    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF, GET_MODRM_REG (modrm), w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, GET_MODRM_REG (modrm), w1);
}
/* 16: 0x33: xor Gw,Ew */
/* 32: 0x33: xor Gd,Ed */
OP1 (xorGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        /* HERE BE DRAGONS */
        if (0xc0 == modrm) {
            w1 = 0;
            wF = (ZF | PF)|(rF & ~ (OSZAPC));
        }
        else {
            B_OP_DWORD (xor, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  33    xor    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        /* HERE BE DRAGONS */
        if (0xc0 == modrm) {
            w1 = 0;
            wF = (ZF | PF)|(rF & ~ (OSZAPC));
        }
        else {
            B_OP_WORD (xor, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  33    xor    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x gx[%d]=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF,
                    GET_MODRM_REG (modrm), w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
    }
}
/* any: 0x34: xor AL,Ib */
OP1 (xorALIb)
{
    BYTE r1, r2, w1;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_BYTE (xor, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  34    xor    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AL, w1);
}
/* 16: 0x35: xor AX,Iw */
/* 32: 0x35: xor EAX,Id */
OP1 (xoreAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_DWORD (xor, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  35    xor   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_DWORD_REG (env, _REG_EAX, w1);
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_WORD (xor, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  35    xor    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF,
                    w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        WRITE_WORD_REG (env, _REG_AX, w1);
    }
}
/* any: 0x37: aaa  */
OP1 (aaa)
{
    BYTE rAH, rAL, wAH, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAH = READ_BYTE_REG (env, _REG_AH);
    rAL = READ_BYTE_REG (env, _REG_AL);
    wF = rF;
    if (((rAL & 0x0F) > 9) || (rF & AF)) {
        wAL = (rAL + 6) & 0xF;
        wAH = rAH + 1;
        wF |= AF;
        wF |= CF;
    }
    else {
        wAL = rAL;
        wAH = rAH;
        wF &= ~ AF;
        wF &= ~ CF;
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  37    aaa         : in: f=%x AH=%x AL=%x out: f=%x AH=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAH, rAL,wF,
                wAH, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AH, wAH);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* any: 0x38: cmp Eb,Gb */
OP1 (cmpEbGb)
{
    BYTE r1, r2, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_NO_RESULT_BYTE (cmp, r1, r2, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  38    cmp    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x39: cmp Ew,Gw */
/* 32: 0x39: cmp Ed,Gd */
OP1 (cmpEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_NO_RESULT_DWORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  39    cmp    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        BYTE modrm;
        WORD r1, r2;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_NO_RESULT_WORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  39    cmp    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* any: 0x3a: cmp Gb,Eb */
OP1 (cmpGbEb)
{
    BYTE r1, r2, modrm;
    DWORD rF, wF;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    if (IS_MODRM_MEM (modrm)) {
        DWORD rm;
        rm = LEA (env, modrm);
        r2 = READ_BYTE_MEM (env, rm);
    }
    else {
        DWORD rm;
        rm = GET_MODRM_RM (modrm);
        r2 = READ_BYTE_REG (env, rm);
    }
    B_OP_NO_RESULT_BYTE (cmp, r1, r2, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  3a    cmp    Gb,Eb: in: f=%x gx[%d]=%x r/m=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                GET_MODRM_REG (modrm), r1, r2,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x3b: cmp Gw,Ew */
/* 32: 0x3b: cmp Gd,Ed */
OP1 (cmpGvEv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_DWORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_DWORD_REG (env, rm);
        }
        B_OP_NO_RESULT_DWORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  3b    cmp    Gd,Ed: in: f=%x gx[%d]=%x r/m=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        BYTE modrm;
        WORD r1, r2;
        DWORD rF, wF;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2 = READ_WORD_MEM (env, rm);
        }
        else {
            DWORD rm;
            rm = GET_MODRM_RM (modrm);
            r2 = READ_WORD_REG (env, rm);
        }
        B_OP_NO_RESULT_WORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  3b    cmp    Gw,Ew: in: f=%x gx[%d]=%x r/m=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                    GET_MODRM_REG (modrm), r1, r2,wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* 16: 0x6: pushw ES */
/* 32: 0x6: pushd ES */
OP1 (pushES)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_ES);
        PUSH_DWORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   6   push       ES: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
    else {
        WORD r1;
        r1 = READ_SEGMENT_REG (env, _SEG_ES);
        PUSH_WORD (env, r1);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   6   push       ES: in: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
        
    }
}
/* any: 0x3c: cmp AL,Ib */
OP1 (cmpALIb)
{
    BYTE r1, r2;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    r1 = READ_BYTE_REG (env, _REG_AL);
    
    r2 = FETCH_BYTE (env);
    B_OP_NO_RESULT_BYTE (cmp, r1, r2, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  3c    cmp    AL,Ib: in: f=%x AL=%x imm=%x out: f=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,wF);
    
    WRITE_DWORD_FLAGS (env, wF);
}
/* 16: 0x3d: cmp AX,Iw */
/* 32: 0x3d: cmp EAX,Id */
OP1 (cmpeAXIv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_DWORD_REG (env, _REG_EAX);
        
        r2 = FETCH_DWORD (env);
        B_OP_NO_RESULT_DWORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  3d    cmp   EAX,Id: in: f=%x EAX=%x imm=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,
                    wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
    else {
        WORD r1, r2;
        DWORD rF, wF;
        rF = READ_DWORD_FLAGS (env);
        r1 = READ_WORD_REG (env, _REG_AX);
        
        r2 = FETCH_WORD (env);
        B_OP_NO_RESULT_WORD (cmp, r1, r2, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  3d    cmp    AX,Iw: in: f=%x AX=%x imm=%x out: f=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1, r2,
                    wF);
        
        WRITE_DWORD_FLAGS (env, wF);
    }
}
/* any: 0x3f: aas  */
OP1 (aas)
{
    BYTE rAH, rAL, wAH, wAL;
    DWORD rF, wF;
    rF = READ_DWORD_FLAGS (env);
    rAH = READ_BYTE_REG (env, _REG_AH);
    rAL = READ_BYTE_REG (env, _REG_AL);
    wF = rF;
    if (((rAL & 0xff) > 9) || (rF & AF)) {
        wAL = rAL - 6;
        wAL &= 0xf;
        wAH = rAH - 1;
        wF |= AF;
        wF |= CF;
    }
    else {
        wAL = rAL;
        wAH = rAH;
        wF &= ~ AF;
        wF &= ~ CF;
    }
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  3f    aas         : in: f=%x AH=%x AL=%x out: f=%x AH=%x AL=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, rAH, rAL,wF,
                wAH, wAL);
    
    WRITE_DWORD_FLAGS (env, wF);
    WRITE_BYTE_REG (env, _REG_AH, wAH);
    WRITE_BYTE_REG (env, _REG_AL, wAL);
}
/* 16: 0x7: popw ES */
/* 32: 0x7: popd ES */
OP1 (popES)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        WORD w1;
        w1 = POP_DWORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   7    pop       ES: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_ES, w1);
    }
    else {
        WORD w1;
        w1 = POP_WORD (env);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   7    pop       ES: out: seg=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
        
        WRITE_SEGMENT_REG (env, _SEG_ES, w1);
    }
}
/* any: 0x8: or Eb,Gb */
OP1 (orEbGb)
{
    BYTE r1, r2, w1, modrm;
    DWORD rF, wF, rm;
    modrm = FETCH_BYTE (env);
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, GET_MODRM_REG (modrm));
    B_OP_BYTE (or, r1, r2, w1, wF);
    MOVE_FLAGS_OSZAPC (wF, rF);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x   8     or    Eb,Gb: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                GET_MODRM_REG (modrm), r2,wF, w1);
    
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
/* 16: 0x9: or Ew,Gw */
/* 32: 0x9: or Ed,Gd */
OP1 (orEvGv)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD rF, r1, r2, wF, w1, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_DWORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   9     or    Ed,Gd: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE modrm;
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        modrm = FETCH_BYTE (env);
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        B_OP_WORD (or, r1, r2, w1, wF);
        MOVE_FLAGS_OSZAPC (wF, rF);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x   9     or    Ew,Gw: in: f=%x r/m=%x gx[%d]=%x out: f=%x r/m=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                    GET_MODRM_REG (modrm), r2,wF, w1);
        
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
/* 16: 0x60: pusha  */
/* 32: 0x60: pushad  */
OP1 (pusha)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rESP, rEBP, rEDI, rESI, rEDX, rECX, rEBX, rEAX;
        rESP = READ_DWORD_REG (env, _REG_ESP);
        rEBP = READ_DWORD_REG (env, _REG_EBP);
        rEDI = READ_DWORD_REG (env, _REG_EDI);
        rESI = READ_DWORD_REG (env, _REG_ESI);
        rEDX = READ_DWORD_REG (env, _REG_EDX);
        rECX = READ_DWORD_REG (env, _REG_ECX);
        rEBX = READ_DWORD_REG (env, _REG_EBX);
        rEAX = READ_DWORD_REG (env, _REG_EAX);
        PUSH_DWORD (env, rEAX);
        PUSH_DWORD (env, rECX);
        PUSH_DWORD (env, rEDX);
        PUSH_DWORD (env, rEBX);
        PUSH_DWORD (env, rESP);
        PUSH_DWORD (env, rEBP);
        PUSH_DWORD (env, rESI);
        PUSH_DWORD (env, rEDI);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  60  pusha         : in: ESP=%x EBP=%x EDI=%x ESI=%x EDX=%x ECX=%x EBX=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rESP, rEBP,
                    rEDI, rESI, rEDX, rECX, rEBX, rEAX);
        
    }
    else {
        WORD rSP, rBP, rDI, rSI, rDX, rCX, rBX, rAX;
        rSP = READ_WORD_REG (env, _REG_SP);
        rBP = READ_WORD_REG (env, _REG_BP);
        rDI = READ_WORD_REG (env, _REG_DI);
        rSI = READ_WORD_REG (env, _REG_SI);
        rDX = READ_WORD_REG (env, _REG_DX);
        rCX = READ_WORD_REG (env, _REG_CX);
        rBX = READ_WORD_REG (env, _REG_BX);
        rAX = READ_WORD_REG (env, _REG_AX);
        PUSH_WORD (env, rAX);
        PUSH_WORD (env, rCX);
        PUSH_WORD (env, rDX);
        PUSH_WORD (env, rBX);
        PUSH_WORD (env, rSP);
        PUSH_WORD (env, rBP);
        PUSH_WORD (env, rSI);
        PUSH_WORD (env, rDI);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  60  pusha         : in: SP=%x BP=%x DI=%x SI=%x DX=%x CX=%x BX=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,rSP, rBP, rDI,
                    rSI, rDX, rCX, rBX, rAX);
        
    }
}
/* 16: 0x61: popa  */
/* 32: 0x61: popad  */
OP1 (popa)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD wEDI, wESI, wEBP, wEBX, wEDX, wECX, wEAX;
        {
            DWORD tmp;
        
            wEDI = POP_DWORD (env);
            wESI = POP_DWORD (env);
            wEBP = POP_DWORD (env);
            tmp = POP_DWORD (env);
            wEBX = POP_DWORD (env);
            wEDX = POP_DWORD (env);
            wECX = POP_DWORD (env);
            wEAX = POP_DWORD (env);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  61   popa         : out: EDI=%x ESI=%x EBP=%x EBX=%x EDX=%x ECX=%x EAX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,wEDI, wESI,
                    wEBP, wEBX, wEDX, wECX, wEAX);
        
        WRITE_DWORD_REG (env, _REG_EDI, wEDI);
        WRITE_DWORD_REG (env, _REG_ESI, wESI);
        WRITE_DWORD_REG (env, _REG_EBP, wEBP);
        WRITE_DWORD_REG (env, _REG_EBX, wEBX);
        WRITE_DWORD_REG (env, _REG_EDX, wEDX);
        WRITE_DWORD_REG (env, _REG_ECX, wECX);
        WRITE_DWORD_REG (env, _REG_EAX, wEAX);
    }
    else {
        WORD wDI, wSI, wBP, wBX, wDX, wCX, wAX;
        {
            WORD tmp;
        
            wDI = POP_WORD (env);
            wSI = POP_WORD (env);
            wBP = POP_WORD (env);
            tmp = POP_WORD (env);
            wBX = POP_WORD (env);
            wDX = POP_WORD (env);
            wCX = POP_WORD (env);
            wAX = POP_WORD (env);
        }
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  61   popa         : out: DI=%x SI=%x BP=%x BX=%x DX=%x CX=%x AX=%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,wDI, wSI, wBP,
                    wBX, wDX, wCX, wAX);
        
        WRITE_WORD_REG (env, _REG_DI, wDI);
        WRITE_WORD_REG (env, _REG_SI, wSI);
        WRITE_WORD_REG (env, _REG_BP, wBP);
        WRITE_WORD_REG (env, _REG_BX, wBX);
        WRITE_WORD_REG (env, _REG_DX, wDX);
        WRITE_WORD_REG (env, _REG_CX, wCX);
        WRITE_WORD_REG (env, _REG_AX, wAX);
    }
}
/* 16: 0x62: bound Gw,Ma */
/* 32: 0x62: bound Gd,Ma */
OP1 (boundGvMa)
{
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE modrm;
        DWORD r1, r2_hi, r2_lo;
        modrm = FETCH_BYTE (env);
        r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_lo = READ_DWORD_MEM (env, rm);
            r2_hi = READ_DWORD_MEM (env, rm + 4);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        if ((r1 > r2_hi) || (r1 < r2_lo))
            EXCEPTION (env, 6, 0);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  62  bound    Gd,Ma: in: gx[%d]=%x lo:hi=%x,%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    GET_MODRM_REG (modrm), r1, r2_hi, r2_lo);
        
    }
    else {
        BYTE modrm;
        WORD r1, r2_hi, r2_lo;
        modrm = FETCH_BYTE (env);
        r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
        if (IS_MODRM_MEM (modrm)) {
            DWORD rm;
            rm = LEA (env, modrm);
            r2_lo = READ_WORD_MEM (env, rm);
            r2_hi = READ_WORD_MEM (env, rm + 2);
        }
        else {
            EXCEPTION (env, 6, 0); return;
        }
        if ((r1 > r2_hi) || (r1 < r2_lo))
            EXCEPTION (env, 6, 0);
        if (NULL != turtle_log)
            fprintf (turtle_log, "%08x  62  bound    Gw,Ma: in: gx[%d]=%x lo:hi=%x,%x\n",
                    (DWORD) env->segs[_SEG_CS].base + env->eip,
                    GET_MODRM_REG (modrm), r1, r2_hi, r2_lo);
        
    }
}
/* any: 0x63: arpl Ew,Rw */
OP1 (arplEwRw)
{
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x  63   arpl    Ew,Rw:\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
OP1 (group_13)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    (void) opno;
    NOT_IMPLEMENTED (env);
    if (NULL != turtle_log)
        fprintf (turtle_log, "%08x 269    str       Ew:\n",
                (DWORD) env->segs[_SEG_CS].base + env->eip);
    
}
OP1 (group_12)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        switch (opno) {
            case 0x3:
            {
                 NOT_IMPLEMENTED (env);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 263   call       Ep:\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip);
                 
                 break;
            }
            case 0x5:
            {
                 NOT_IMPLEMENTED (env);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 265    jmp       Ep:\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip);
                 
                 break;
            }
            case 0x2:
            {
                 DWORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 PUSH_DWORD (env, NEXT_IP (env));
                 JUMP_NEAR_ABSOLUTE_DWORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 262   call       Ed: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0x4:
            {
                 DWORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 JUMP_NEAR_ABSOLUTE_DWORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 264    jmp       Ed: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0x6:
            {
                 DWORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 PUSH_DWORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 266   push       Ed: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0:
            {
                 DWORD rF, r1, wF, w1, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 U_OP_DWORD (inc, r1, w1, wF);
                 MOVE_FLAGS_OSZAP (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 260    inc       Ed: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_DWORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_DWORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0x1:
            {
                 DWORD rF, r1, wF, w1, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 U_OP_DWORD (dec, r1, w1, wF);
                 MOVE_FLAGS_OSZAP (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 261    dec       Ed: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_DWORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_DWORD_REG (env, rm, w1);
                 }
                 break;
            }
        }
    }
    else {
        switch (opno) {
            case 0x3:
            {
                 NOT_IMPLEMENTED (env);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 263   call       Ep:\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip);
                 
                 break;
            }
            case 0x5:
            {
                 NOT_IMPLEMENTED (env);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 265    jmp       Ep:\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip);
                 
                 break;
            }
            case 0x2:
            {
                 WORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 PUSH_WORD (env, NEXT_IP (env));
                 JUMP_NEAR_ABSOLUTE_WORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 262   call       Ew: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0x4:
            {
                 WORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 JUMP_NEAR_ABSOLUTE_WORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 264    jmp       Ew: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0x6:
            {
                 WORD r1;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 PUSH_WORD (env, r1);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 266   push       Ew: in: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
                 break;
            }
            case 0:
            {
                 WORD r1, w1;
                 DWORD rF, wF, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 U_OP_WORD (inc, r1, w1, wF);
                 MOVE_FLAGS_OSZAP (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 260    inc       Ew: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_WORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_WORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0x1:
            {
                 WORD r1, w1;
                 DWORD rF, wF, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 U_OP_WORD (dec, r1, w1, wF);
                 MOVE_FLAGS_OSZAP (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 261    dec       Ew: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_WORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_WORD_REG (env, rm, w1);
                 }
                 break;
            }
        }
    }
}
OP1 (group_11)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    BYTE r1, w1;
    DWORD rF, wF, rm;
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    switch (opno) {
        case 0:
        {
            U_OP_BYTE (inc, r1, w1, wF);
            MOVE_FLAGS_OSZAP (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 258    inc       Eb: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 1:
        {
            U_OP_BYTE (dec, r1, w1, wF);
            MOVE_FLAGS_OSZAP (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 259    dec       Eb: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        default: NOT_IMPLEMENTED (env); return;
        
    }
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
OP1 (group_10)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        switch (opno) {
            case 0x2:
            {
                 DWORD r1, w1, rm;
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 w1 = ~ r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 252    not       Ed: in: r/m=%x out: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                             w1);
                 
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_DWORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_DWORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0x3:
            {
                 DWORD rF, r1, wF, w1, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 U_OP_DWORD (neg, r1, w1, wF);
                 MOVE_FLAGS_OSZAPC (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 253    neg       Ed: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_DWORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_DWORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0:
            {
                 DWORD rF, r1, r2, wF;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_DWORD_REG (env, rm);
                 }
                 
                 r2 = FETCH_DWORD (env);
                 B_OP_NO_RESULT_DWORD (test, r1, r2, wF);
                 MOVE_FLAGS_OSZAPC (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 250   test    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 break;
            }
            case 0x7:
            {
                 DWORD rHI, rLO, wREM;
                 SDWORD r2, wQUO;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = (SDWORD) READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = (SDWORD) READ_DWORD_REG (env, rm);
                 }
                 rHI = READ_DWORD_REG (env, _REG_EDX);
                 rLO = READ_DWORD_REG (env, _REG_EAX);
                 if (0 == r2) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
                 else {
                     SQWORD num, quo;
                 
                     num = ((QWORD) rHI << 32) | rLO;
                     quo = num / r2;
                     wREM = num % r2;
                     wQUO = quo;
                     if (quo != wQUO) {
                         EXCEPTION (env, 0, 0);
                         return;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 257   idiv   EAX,Ed: in: r/m=%x EDX=%x EAX=%x out: EDX=%x EAX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                             rHI, rLO,wREM, wQUO);
                 
                 WRITE_DWORD_REG (env, _REG_EDX, wREM);
                 WRITE_DWORD_REG (env, _REG_EAX, wQUO);
                 break;
            }
            case 0x6:
            {
                 DWORD r2, rHI, rLO, wREM, wQUO;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 rHI = READ_DWORD_REG (env, _REG_EDX);
                 rLO = READ_DWORD_REG (env, _REG_EAX);
                 if (0 == r2) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
                 else {
                     QWORD num, quo;
                 
                     num = ((QWORD) rHI << 32) | rLO;
                     quo = num / r2;
                     wREM = num % r2;
                     wQUO = quo;
                 
                     if (quo != wQUO) {
                         EXCEPTION (env, 0, 0);
                         return;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 256    div   EAX,Ed: in: r/m=%x EDX=%x EAX=%x out: EDX=%x EAX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                             rHI, rLO,wREM, wQUO);
                 
                 WRITE_DWORD_REG (env, _REG_EDX, wREM);
                 WRITE_DWORD_REG (env, _REG_EAX, wQUO);
                 break;
            }
            case 0x5:
            {
                 DWORD rF, wF;
                 SDWORD r1, r2, wHI, wLO;
                 rF = READ_DWORD_FLAGS (env);
                 r1 = (SDWORD) READ_DWORD_REG (env, _REG_EAX);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = (SDWORD) READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = (SDWORD) READ_DWORD_REG (env, rm);
                 }
                 {
                     SQWORD tmp;
                 
                     tmp = r1;
                     tmp *= r2;
                     wLO = tmp;
                     wHI = tmp >> 32;
                 
                     if (wHI == -((wLO >> (32 - 1)) & 1)) {
                         wF = rF & ~ OC;
                     }
                     else {
                         wF = rF | OC;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 255   imul   EAX,Ed: in: f=%x EAX=%x r/m=%x out: f=%x EDX=%x EAX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF, wHI, wLO);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 WRITE_DWORD_REG (env, _REG_EDX, wHI);
                 WRITE_DWORD_REG (env, _REG_EAX, wLO);
                 break;
            }
            case 0x4:
            {
                 DWORD rF, r1, r2, wF, wHI, wLO;
                 rF = READ_DWORD_FLAGS (env);
                 r1 = READ_DWORD_REG (env, _REG_EAX);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 {
                     QWORD tmp;
                 
                     tmp = r1;
                     tmp *= r2;
                     wLO = tmp;
                     wHI = tmp >> 32;
                 
                     if (0 == wHI) {
                         wF = rF & ~ OC;
                     }
                     else {
                         wF = rF | OC;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 254    mul   EAX,Ed: in: f=%x EAX=%x r/m=%x out: f=%x EDX=%x EAX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF, wHI, wLO);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 WRITE_DWORD_REG (env, _REG_EDX, wHI);
                 WRITE_DWORD_REG (env, _REG_EAX, wLO);
                 break;
            }
        }
    }
    else {
        switch (opno) {
            case 0x2:
            {
                 WORD r1, w1;
                 DWORD rm;
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 w1 = ~ r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 252    not       Ew: in: r/m=%x out: r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                             w1);
                 
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_WORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_WORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0x3:
            {
                 WORD r1, w1;
                 DWORD rF, wF, rm;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 U_OP_WORD (neg, r1, w1, wF);
                 MOVE_FLAGS_OSZAPC (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 253    neg       Ew: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1,wF, w1);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 if (IS_MODRM_MEM (modrm)) {
                     /* NOT LOCAL 2 0 */
                     if (0 == (env->iflags & IF_CONFIRM))
                     WRITE_WORD_MEM (env, rm, w1);
                 }
                 else {
                     /* NOT LOCAL 2 0 */
                     WRITE_WORD_REG (env, rm, w1);
                 }
                 break;
            }
            case 0:
            {
                 WORD r1, r2;
                 DWORD rF, wF;
                 rF = READ_DWORD_FLAGS (env);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r1 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r1 = READ_WORD_REG (env, rm);
                 }
                 
                 r2 = FETCH_WORD (env);
                 B_OP_NO_RESULT_WORD (test, r1, r2, wF);
                 MOVE_FLAGS_OSZAPC (wF, rF);
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 250   test    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 break;
            }
            case 0x7:
            {
                 WORD rHI, rLO, wREM;
                 SWORD r2, wQUO;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = (SWORD) READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = (SWORD) READ_WORD_REG (env, rm);
                 }
                 rHI = READ_WORD_REG (env, _REG_DX);
                 rLO = READ_WORD_REG (env, _REG_AX);
                 if (0 == r2) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
                 else {
                     SDWORD num, quo;
                 
                     num = ((DWORD) rHI << 16) | rLO;
                     quo = num / r2;
                     wREM = num % r2;
                     wQUO = quo;
                     if (quo != wQUO) {
                         EXCEPTION (env, 0, 0);
                         return;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 257   idiv    AX,Ew: in: r/m=%x DX=%x AX=%x out: DX=%x AX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                             rHI, rLO,wREM, wQUO);
                 
                 WRITE_WORD_REG (env, _REG_DX, wREM);
                 WRITE_WORD_REG (env, _REG_AX, wQUO);
                 break;
            }
            case 0x6:
            {
                 WORD r2, rHI, rLO, wREM, wQUO;
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 rHI = READ_WORD_REG (env, _REG_DX);
                 rLO = READ_WORD_REG (env, _REG_AX);
                 if (0 == r2) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
                 else {
                     DWORD num, quo;
                 
                     num = ((DWORD) rHI << 16) | rLO;
                     quo = num / r2;
                     wREM = num % r2;
                     wQUO = quo;
                 
                     if (quo != wQUO) {
                         EXCEPTION (env, 0, 0);
                         return;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 256    div    AX,Ew: in: r/m=%x DX=%x AX=%x out: DX=%x AX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                             rHI, rLO,wREM, wQUO);
                 
                 WRITE_WORD_REG (env, _REG_DX, wREM);
                 WRITE_WORD_REG (env, _REG_AX, wQUO);
                 break;
            }
            case 0x5:
            {
                 DWORD rF, wF;
                 SWORD r1, r2, wHI, wLO;
                 rF = READ_DWORD_FLAGS (env);
                 r1 = (SWORD) READ_WORD_REG (env, _REG_AX);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = (SWORD) READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = (SWORD) READ_WORD_REG (env, rm);
                 }
                 {
                     SDWORD tmp;
                 
                     tmp = r1;
                     tmp *= r2;
                     wLO = tmp;
                     wHI = tmp >> 16;
                 
                     if (wHI == -((wLO >> (16 - 1)) & 1)) {
                         wF = rF & ~ OC;
                     }
                     else {
                         wF = rF | OC;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 255   imul    AX,Ew: in: f=%x AX=%x r/m=%x out: f=%x DX=%x AX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF, wHI, wLO);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 WRITE_WORD_REG (env, _REG_DX, wHI);
                 WRITE_WORD_REG (env, _REG_AX, wLO);
                 break;
            }
            case 0x4:
            {
                 WORD r1, r2, wHI, wLO;
                 DWORD rF, wF;
                 rF = READ_DWORD_FLAGS (env);
                 r1 = READ_WORD_REG (env, _REG_AX);
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 {
                     DWORD tmp;
                 
                     tmp = r1;
                     tmp *= r2;
                     wLO = tmp;
                     wHI = tmp >> 16;
                 
                     if (0 == wHI) {
                         wF = rF & ~ OC;
                     }
                     else {
                         wF = rF | OC;
                     }
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 254    mul    AX,Ew: in: f=%x AX=%x r/m=%x out: f=%x DX=%x AX=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                             r1, r2,wF, wHI, wLO);
                 
                 WRITE_DWORD_FLAGS (env, wF);
                 WRITE_WORD_REG (env, _REG_DX, wHI);
                 WRITE_WORD_REG (env, _REG_AX, wLO);
                 break;
            }
        }
    }
}
OP1 (group_9)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    switch (opno) {
        case 0x7:
        {
             BYTE rHI, rLO, wREM;
             SBYTE r2, wQUO;
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 r2 = (SBYTE) READ_BYTE_MEM (env, rm);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 r2 = (SBYTE) READ_BYTE_REG (env, rm);
             }
             rHI = READ_BYTE_REG (env, _REG_AH);
             rLO = READ_BYTE_REG (env, _REG_AL);
             if (0 == r2) {
                 EXCEPTION (env, 0, 0);
                 return;
             }
             else {
                 SWORD num, quo;
             
                 num = ((WORD) rHI << 8) | rLO;
                 quo = num / r2;
                 wREM = num % r2;
                 wQUO = quo;
                 if (quo != wQUO) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
             }
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24f   idiv    AL,Eb: in: r/m=%x AH=%x AL=%x out: AH=%x AL=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,r2, rHI,
                         rLO,wREM, wQUO);
             
             WRITE_BYTE_REG (env, _REG_AH, wREM);
             WRITE_BYTE_REG (env, _REG_AL, wQUO);
             break;
        }
        case 0x6:
        {
             BYTE r2, rHI, rLO, wREM, wQUO;
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 r2 = READ_BYTE_MEM (env, rm);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 r2 = READ_BYTE_REG (env, rm);
             }
             rHI = READ_BYTE_REG (env, _REG_AH);
             rLO = READ_BYTE_REG (env, _REG_AL);
             if (0 == r2) {
                 EXCEPTION (env, 0, 0);
                 return;
             }
             else {
                 WORD num, quo;
             
                 num = ((WORD) rHI << 8) | rLO;
                 quo = num / r2;
                 wREM = num % r2;
                 wQUO = quo;
             
                 if (quo != wQUO) {
                     EXCEPTION (env, 0, 0);
                     return;
                 }
             }
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24e    div    AL,Eb: in: r/m=%x AH=%x AL=%x out: AH=%x AL=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,r2, rHI,
                         rLO,wREM, wQUO);
             
             WRITE_BYTE_REG (env, _REG_AH, wREM);
             WRITE_BYTE_REG (env, _REG_AL, wQUO);
             break;
        }
        case 0x5:
        {
             DWORD rF, wF;
             SBYTE r1, r2, wHI, wLO;
             rF = READ_DWORD_FLAGS (env);
             r1 = (SBYTE) READ_BYTE_REG (env, _REG_AL);
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 r2 = (SBYTE) READ_BYTE_MEM (env, rm);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 r2 = (SBYTE) READ_BYTE_REG (env, rm);
             }
             {
                 SWORD tmp;
             
                 tmp = r1;
                 tmp *= r2;
                 wLO = tmp;
                 wHI = tmp >> 8;
             
                 if (wHI == -((wLO >> (8 - 1)) & 1)) {
                     wF = rF & ~ OC;
                 }
                 else {
                     wF = rF | OC;
                 }
             }
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24d   imul    AL,Eb: in: f=%x AL=%x r/m=%x out: f=%x AH=%x AL=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                         r2,wF, wHI, wLO);
             
             WRITE_DWORD_FLAGS (env, wF);
             WRITE_BYTE_REG (env, _REG_AH, wHI);
             WRITE_BYTE_REG (env, _REG_AL, wLO);
             break;
        }
        case 0x4:
        {
             BYTE r1, r2, wHI, wLO;
             DWORD rF, wF;
             rF = READ_DWORD_FLAGS (env);
             r1 = READ_BYTE_REG (env, _REG_AL);
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 r2 = READ_BYTE_MEM (env, rm);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 r2 = READ_BYTE_REG (env, rm);
             }
             {
                 WORD tmp;
             
                 tmp = r1;
                 tmp *= r2;
                 wLO = tmp;
                 wHI = tmp >> 8;
             
                 if (0 == wHI) {
                     wF = rF & ~ OC;
                 }
                 else {
                     wF = rF | OC;
                 }
             }
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24c    mul    AL,Eb: in: f=%x AL=%x r/m=%x out: f=%x AH=%x AL=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                         r2,wF, wHI, wLO);
             
             WRITE_DWORD_FLAGS (env, wF);
             WRITE_BYTE_REG (env, _REG_AH, wHI);
             WRITE_BYTE_REG (env, _REG_AL, wLO);
             break;
        }
        case 0x2:
        {
             BYTE r1, w1;
             DWORD rm;
             if (IS_MODRM_MEM (modrm)) {
                 rm = LEA (env, modrm);
                 r1 = READ_BYTE_MEM (env, rm);
             }
             else {
                 rm = GET_MODRM_RM (modrm);
                 r1 = READ_BYTE_REG (env, rm);
             }
             w1 = ~ r1;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24a    not       Eb: in: r/m=%x out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,r1,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 /* NOT LOCAL 2 0 */
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 /* NOT LOCAL 2 0 */
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
        }
        case 0x3:
        {
             BYTE r1, w1;
             DWORD rF, wF, rm;
             rF = READ_DWORD_FLAGS (env);
             if (IS_MODRM_MEM (modrm)) {
                 rm = LEA (env, modrm);
                 r1 = READ_BYTE_MEM (env, rm);
             }
             else {
                 rm = GET_MODRM_RM (modrm);
                 r1 = READ_BYTE_REG (env, rm);
             }
             U_OP_BYTE (neg, r1, w1, wF);
             MOVE_FLAGS_OSZAPC (wF, rF);
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 24b    neg       Eb: in: f=%x r/m=%x out: f=%x r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                         wF, w1);
             
             WRITE_DWORD_FLAGS (env, wF);
             if (IS_MODRM_MEM (modrm)) {
                 /* NOT LOCAL 2 0 */
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 /* NOT LOCAL 2 0 */
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
        }
        case 0:
        {
             BYTE r1, r2;
             DWORD rF, wF;
             rF = READ_DWORD_FLAGS (env);
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 r1 = READ_BYTE_MEM (env, rm);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 r1 = READ_BYTE_REG (env, rm);
             }
             
             r2 = FETCH_BYTE (env);
             B_OP_NO_RESULT_BYTE (test, r1, r2, wF);
             MOVE_FLAGS_OSZAPC (wF, rF);
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 248   test    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                         r2,wF);
             
             WRITE_DWORD_FLAGS (env, wF);
             break;
        }
    }
}
OP1 (group_8)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2;
        DWORD rF, r1, wF, w1, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = READ_BYTE_REG (env, _REG_CL);
        switch (opno) {
            case 0:
            {
                S_OP_DWORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 240    rol    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_DWORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 241    ror    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_DWORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 242    rcl    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_DWORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 243    rcr    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_DWORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 244    shl    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_DWORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 245    shr    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_DWORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 247    sar    Ed,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r2;
        WORD r1, w1;
        DWORD rF, wF, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = READ_BYTE_REG (env, _REG_CL);
        switch (opno) {
            case 0:
            {
                S_OP_WORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 240    rol    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_WORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 241    ror    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_WORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 242    rcl    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_WORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 243    rcr    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_WORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 244    shl    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_WORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 245    shr    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_WORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 247    sar    Ew,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
OP1 (group_7)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    BYTE r1, r2, w1;
    DWORD rF, wF, rm;
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = READ_BYTE_REG (env, _REG_CL);
    switch (opno) {
        case 0:
        {
            S_OP_BYTE (rol, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 238    rol    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 1:
        {
            S_OP_BYTE (ror, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 239    ror    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 2:
        {
            S_OP_CARRY_BYTE (rcl, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 23a    rcl    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 3:
        {
            S_OP_CARRY_BYTE (rcr, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 23b    rcr    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 4:
        {
            S_OP_BYTE (shl, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 23c    shl    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 5:
        {
            S_OP_BYTE (shr, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 23d    shr    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 7:
        {
            S_OP_BYTE (sar, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 23f    sar    Eb,CL: in: f=%x r/m=%x CL=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        default: NOT_IMPLEMENTED (env); return;
        
    }
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
OP1 (group_6)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2;
        DWORD rF, r1, wF, w1, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        r2 = 1;
        switch (opno) {
            case 0:
            {
                S_OP_DWORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 230    rol    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_DWORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 231    ror    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_DWORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 232    rcl    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_DWORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 233    rcr    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_DWORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 234    shl    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_DWORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 235    shr    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_DWORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 237    sar    Ed, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r2;
        WORD r1, w1;
        DWORD rF, wF, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        r2 = 1;
        switch (opno) {
            case 0:
            {
                S_OP_WORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 230    rol    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_WORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 231    ror    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_WORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 232    rcl    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_WORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 233    rcr    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_WORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 234    shl    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_WORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 235    shr    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_WORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 237    sar    Ew, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
OP1 (group_5)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    BYTE r1, r2, w1;
    DWORD rF, wF, rm;
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    r2 = 1;
    switch (opno) {
        case 0:
        {
            S_OP_BYTE (rol, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 228    rol    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 1:
        {
            S_OP_BYTE (ror, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 229    ror    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 2:
        {
            S_OP_CARRY_BYTE (rcl, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 22a    rcl    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 3:
        {
            S_OP_CARRY_BYTE (rcr, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 22b    rcr    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 4:
        {
            S_OP_BYTE (shl, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 22c    shl    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 5:
        {
            S_OP_BYTE (shr, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 22d    shr    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        case 7:
        {
            S_OP_BYTE (sar, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 22f    sar    Eb, 1: in: f=%x r/m=%x  out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,wF,
                        w1);
            
            break;
        }
        default: NOT_IMPLEMENTED (env); return;
        
    }
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
OP1 (group_4)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        BYTE r2;
        DWORD rF, r1, wF, w1, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        
        r2 = FETCH_BYTE (env);
        switch (opno) {
            case 0:
            {
                S_OP_DWORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 220    rol    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_DWORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 221    ror    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_DWORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 222    rcl    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_DWORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 223    rcr    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_DWORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 224    shl    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_DWORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 225    shr    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_DWORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 227    sar    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        BYTE r2;
        WORD r1, w1;
        DWORD rF, wF, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        
        r2 = FETCH_BYTE (env);
        switch (opno) {
            case 0:
            {
                S_OP_WORD (rol, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 220    rol    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                S_OP_WORD (ror, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 221    ror    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                S_OP_CARRY_WORD (rcl, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 222    rcl    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                S_OP_CARRY_WORD (rcr, r1, r2, w1, rF, wF);
                if (r2) {
                    MOVE_FLAGS_OC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 223    rcr    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                S_OP_WORD (shl, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 224    shl    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                S_OP_WORD (shr, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 225    shr    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                S_OP_WORD (sar, r1, r2, w1, wF);
                if (r2) {
                    MOVE_FLAGS_OSZAPC (wF, rF);
                }
                else {
                    wF = rF;
                }
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 227    sar    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            default: NOT_IMPLEMENTED (env); return;
            
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
OP1 (group_3)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    BYTE r1, r2, w1;
    DWORD rF, wF, rm;
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    
    r2 = FETCH_BYTE (env);
    switch (opno) {
        case 0:
        {
            S_OP_BYTE (rol, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 218    rol    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 1:
        {
            S_OP_BYTE (ror, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 219    ror    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 2:
        {
            S_OP_CARRY_BYTE (rcl, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 21a    rcl    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 3:
        {
            S_OP_CARRY_BYTE (rcr, r1, r2, w1, rF, wF);
            if (r2) {
                MOVE_FLAGS_OC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 21b    rcr    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 4:
        {
            S_OP_BYTE (shl, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 21c    shl    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 5:
        {
            S_OP_BYTE (shr, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 21d    shr    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 7:
        {
            S_OP_BYTE (sar, r1, r2, w1, wF);
            if (r2) {
                MOVE_FLAGS_OSZAPC (wF, rF);
            }
            else {
                wF = rF;
            }
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 21f    sar    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        default: NOT_IMPLEMENTED (env); return;
        
    }
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
OP1 (group_2)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, wF, w1, rm;
        SDWORD r2;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        
        r2 = (SBYTE) FETCH_BYTE (env);
        switch (opno) {
            default:
            case 0:
            {
                B_OP_DWORD (add, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 210    add    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                B_OP_DWORD (or, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 211     or    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                B_OP_CARRY_DWORD (adc, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 212    adc    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                B_OP_CARRY_DWORD (sbb, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 213    sbb    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                B_OP_DWORD (and, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 214    and    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                B_OP_DWORD (sub, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 215    sub    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 6:
            {
                B_OP_DWORD (xor, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 216    xor    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                /* HERE BE DRAGONS */
                B_OP_NO_RESULT_DWORD (cmp, r1, r2, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                WRITE_DWORD_FLAGS (env, wF);
                return;
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 217    cmp    Ed,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        WORD r1, w1;
        DWORD rF, wF, rm;
        SWORD r2;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        
        r2 = (SBYTE) FETCH_BYTE (env);
        switch (opno) {
            default:
            case 0:
            {
                B_OP_WORD (add, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 210    add    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                B_OP_WORD (or, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 211     or    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                B_OP_CARRY_WORD (adc, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 212    adc    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                B_OP_CARRY_WORD (sbb, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 213    sbb    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                B_OP_WORD (and, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 214    and    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                B_OP_WORD (sub, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 215    sub    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 6:
            {
                B_OP_WORD (xor, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 216    xor    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                /* HERE BE DRAGONS */
                B_OP_NO_RESULT_WORD (cmp, r1, r2, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                WRITE_DWORD_FLAGS (env, wF);
                return;
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 217    cmp    Ew,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
OP1 (group_1)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    if (IS_OPERAND_SIZE_32 (env)) {
        DWORD rF, r1, r2, wF, w1, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_DWORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_DWORD_REG (env, rm);
        }
        
        r2 = FETCH_DWORD (env);
        switch (opno) {
            default:
            case 0:
            {
                B_OP_DWORD (add, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 208    add    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                B_OP_DWORD (or, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 209     or    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                B_OP_CARRY_DWORD (adc, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20a    adc    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                B_OP_CARRY_DWORD (sbb, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20b    sbb    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                B_OP_DWORD (and, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20c    and    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                B_OP_DWORD (sub, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20d    sub    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 6:
            {
                B_OP_DWORD (xor, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20e    xor    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                /* HERE BE DRAGONS */
                B_OP_NO_RESULT_DWORD (cmp, r1, r2, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                WRITE_DWORD_FLAGS (env, wF);
                return;
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20f    cmp    Ed,Id: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_DWORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_DWORD_REG (env, rm, w1);
        }
    }
    else {
        WORD r1, r2, w1;
        DWORD rF, wF, rm;
        rF = READ_DWORD_FLAGS (env);
        if (IS_MODRM_MEM (modrm)) {
            rm = LEA (env, modrm);
            r1 = READ_WORD_MEM (env, rm);
        }
        else {
            rm = GET_MODRM_RM (modrm);
            r1 = READ_WORD_REG (env, rm);
        }
        
        r2 = FETCH_WORD (env);
        switch (opno) {
            default:
            case 0:
            {
                B_OP_WORD (add, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 208    add    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 1:
            {
                B_OP_WORD (or, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 209     or    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 2:
            {
                B_OP_CARRY_WORD (adc, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20a    adc    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 3:
            {
                B_OP_CARRY_WORD (sbb, r1, r2, w1, rF, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20b    sbb    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 4:
            {
                B_OP_WORD (and, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20c    and    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 5:
            {
                B_OP_WORD (sub, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20d    sub    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 6:
            {
                B_OP_WORD (xor, r1, r2, w1, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20e    xor    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
            case 7:
            {
                /* HERE BE DRAGONS */
                B_OP_NO_RESULT_WORD (cmp, r1, r2, wF);
                MOVE_FLAGS_OSZAPC (wF, rF);
                WRITE_DWORD_FLAGS (env, wF);
                return;
                if (NULL != turtle_log)
                    fprintf (turtle_log, "%08x 20f    cmp    Ew,Iw: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                            (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                            r1, r2,wF, w1);
                
                break;
            }
        }
        WRITE_DWORD_FLAGS (env, wF);
        if (IS_MODRM_MEM (modrm)) {
            /* NOT LOCAL 2 0 */
            if (0 == (env->iflags & IF_CONFIRM))
            WRITE_WORD_MEM (env, rm, w1);
        }
        else {
            /* NOT LOCAL 2 0 */
            WRITE_WORD_REG (env, rm, w1);
        }
    }
}
OP1 (group_0)
{
    BYTE modrm = FETCH_BYTE (env);
    BYTE opno = GET_MODRM_REG (modrm);
    BYTE r1, r2, w1;
    DWORD rF, wF, rm;
    rF = READ_DWORD_FLAGS (env);
    if (IS_MODRM_MEM (modrm)) {
        rm = LEA (env, modrm);
        r1 = READ_BYTE_MEM (env, rm);
    }
    else {
        rm = GET_MODRM_RM (modrm);
        r1 = READ_BYTE_REG (env, rm);
    }
    
    r2 = FETCH_BYTE (env);
    switch (opno) {
        default:
        case 0:
        {
            B_OP_BYTE (add, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 200    add    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 1:
        {
            B_OP_BYTE (or, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 201     or    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 2:
        {
            B_OP_CARRY_BYTE (adc, r1, r2, w1, rF, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 202    adc    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 3:
        {
            B_OP_CARRY_BYTE (sbb, r1, r2, w1, rF, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 203    sbb    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 4:
        {
            B_OP_BYTE (and, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 204    and    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 5:
        {
            B_OP_BYTE (sub, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 205    sub    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 6:
        {
            B_OP_BYTE (xor, r1, r2, w1, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 206    xor    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
        case 7:
        {
            /* HERE BE DRAGONS */
            B_OP_NO_RESULT_BYTE (cmp, r1, r2, wF);
            MOVE_FLAGS_OSZAPC (wF, rF);
            WRITE_DWORD_FLAGS (env, wF);
            return;
            if (NULL != turtle_log)
                fprintf (turtle_log, "%08x 207    cmp    Eb,Ib: in: f=%x r/m=%x imm=%x out: f=%x r/m=%x\n",
                        (DWORD) env->segs[_SEG_CS].base + env->eip,rF, r1,
                        r2,wF, w1);
            
            break;
        }
    }
    WRITE_DWORD_FLAGS (env, wF);
    if (IS_MODRM_MEM (modrm)) {
        /* NOT LOCAL 2 0 */
        if (0 == (env->iflags & IF_CONFIRM))
        WRITE_BYTE_MEM (env, rm, w1);
    }
    else {
        /* NOT LOCAL 2 0 */
        WRITE_BYTE_REG (env, rm, w1);
    }
}
void turtle (X86 *_env)
{
     #ifdef __GNUC__
       DWORD cc, save, opcode;
       save = (DWORD) env;
       env = _env;
     #else
       DWORD cc, opcode;
       #define env _env
     #endif
     refetch:
     opcode = FETCH_BYTE (env);
     reswitch:
     switch (opcode) {
         case 0x026: HANDLE_PREFIX_ES (env); goto refetch;
         case 0x02e: HANDLE_PREFIX_CS (env); goto refetch;
         case 0x036: HANDLE_PREFIX_SS (env); goto refetch;
         case 0x03e: HANDLE_PREFIX_DS (env); goto refetch;
         case 0x064: HANDLE_PREFIX_FS (env); goto refetch;
         case 0x065: HANDLE_PREFIX_GS (env); goto refetch;
         case 0x066: HANDLE_PREFIX_O32 (env); goto refetch;
         case 0x067: HANDLE_PREFIX_A32 (env); goto refetch;
         case 0x0f0: HANDLE_PREFIX_LOCK (env); goto refetch;
         case 0x0f2: HANDLE_PREFIX_REPNE (env); goto refetch;
         case 0x0f3: HANDLE_PREFIX_REP (env); goto refetch;
         case 0x00f: opcode = FETCH_BYTE (env) | 0x100; goto reswitch;
         case 00000: C1 (addEbGb); break;
         case 0x001: C1 (addEvGv); break;
         case 0x002: C1 (addGbEb); break;
         case 0x003: C1 (addGvEv); break;
         case 0x004: C1 (addALIb); break;
         case 0x005: C1 (addeAXIv); break;
         case 0x006: C1 (pushES); break;
         case 0x007: C1 (popES); break;
         case 0x008: C1 (orEbGb); break;
         case 0x009: C1 (orEvGv); break;
         case 0x00a: C1 (orGbEb); break;
         case 0x00b: C1 (orGvEv); break;
         case 0x00c: C1 (orALIb); break;
         case 0x00d: C1 (oreAXIv); break;
         case 0x00e: C1 (pushCS); break;
         case 0x010: C1 (adcEbGb); break;
         case 0x011: C1 (adcEvGv); break;
         case 0x012: C1 (adcGbEb); break;
         case 0x013: C1 (adcGvEv); break;
         case 0x014: C1 (adcALIb); break;
         case 0x015: C1 (adceAXIv); break;
         case 0x016: C1 (pushSS); break;
         case 0x017: C1 (popSS); break;
         case 0x018: C1 (sbbEbGb); break;
         case 0x019: C1 (sbbEvGv); break;
         case 0x01a: C1 (sbbGbEb); break;
         case 0x01b: C1 (sbbGvEv); break;
         case 0x01c: C1 (sbbALIb); break;
         case 0x01d: C1 (sbbeAXIv); break;
         case 0x01e: C1 (pushDS); break;
         case 0x01f: C1 (popDS); break;
         case 0x020: C1 (andEbGb); break;
         case 0x021: C1 (andEvGv); break;
         case 0x022: C1 (andGbEb); break;
         case 0x023: C1 (andGvEv); break;
         case 0x024: C1 (andALIb); break;
         case 0x025: C1 (andeAXIv); break;
         case 0x027: C1 (daa); break;
         case 0x028: C1 (subEbGb); break;
         case 0x029: C1 (subEvGv); break;
         case 0x02a: C1 (subGbEb); break;
         case 0x02b: C1 (subGvEv); break;
         case 0x02c: C1 (subALIb); break;
         case 0x02d: C1 (subeAXIv); break;
         case 0x02f: C1 (das); break;
         case 0x030: C1 (xorEbGb); break;
         case 0x031: C1 (xorEvGv); break;
         case 0x032: C1 (xorGbEb); break;
         case 0x033: C1 (xorGvEv); break;
         case 0x034: C1 (xorALIb); break;
         case 0x035: C1 (xoreAXIv); break;
         case 0x037: C1 (aaa); break;
         case 0x038: C1 (cmpEbGb); break;
         case 0x039: C1 (cmpEvGv); break;
         case 0x03a: C1 (cmpGbEb); break;
         case 0x03b: C1 (cmpGvEv); break;
         case 0x03c: C1 (cmpALIb); break;
         case 0x03d: C1 (cmpeAXIv); break;
         case 0x03f: C1 (aas); break;
         case 0x040: 
         #define opcode 64
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  40    inc     regd: in: f=%x EAX=%x out: f=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  40    inc     regw: in: f=%x AX=%x out: f=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x041: 
         #define opcode 65
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  41    inc     regd: in: f=%x ECX=%x out: f=%x ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  41    inc     regw: in: f=%x CX=%x out: f=%x CX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x042: 
         #define opcode 66
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  42    inc     regd: in: f=%x EDX=%x out: f=%x EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  42    inc     regw: in: f=%x DX=%x out: f=%x DX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x043: 
         #define opcode 67
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  43    inc     regd: in: f=%x EBX=%x out: f=%x EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  43    inc     regw: in: f=%x BX=%x out: f=%x BX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x044: 
         #define opcode 68
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  44    inc     regd: in: f=%x ESP=%x out: f=%x ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  44    inc     regw: in: f=%x SP=%x out: f=%x SP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x045: 
         #define opcode 69
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  45    inc     regd: in: f=%x EBP=%x out: f=%x EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  45    inc     regw: in: f=%x BP=%x out: f=%x BP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x046: 
         #define opcode 70
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  46    inc     regd: in: f=%x ESI=%x out: f=%x ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  46    inc     regw: in: f=%x SI=%x out: f=%x SI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x047: 
         #define opcode 71
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  47    inc     regd: in: f=%x EDI=%x out: f=%x EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (inc, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  47    inc     regw: in: f=%x DI=%x out: f=%x DI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x048: 
         #define opcode 72
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  48    dec     regd: in: f=%x EAX=%x out: f=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  48    dec     regw: in: f=%x AX=%x out: f=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x049: 
         #define opcode 73
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  49    dec     regd: in: f=%x ECX=%x out: f=%x ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  49    dec     regw: in: f=%x CX=%x out: f=%x CX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04a: 
         #define opcode 74
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4a    dec     regd: in: f=%x EDX=%x out: f=%x EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4a    dec     regw: in: f=%x DX=%x out: f=%x DX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04b: 
         #define opcode 75
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4b    dec     regd: in: f=%x EBX=%x out: f=%x EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4b    dec     regw: in: f=%x BX=%x out: f=%x BX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04c: 
         #define opcode 76
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4c    dec     regd: in: f=%x ESP=%x out: f=%x ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4c    dec     regw: in: f=%x SP=%x out: f=%x SP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04d: 
         #define opcode 77
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4d    dec     regd: in: f=%x EBP=%x out: f=%x EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4d    dec     regw: in: f=%x BP=%x out: f=%x BP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04e: 
         #define opcode 78
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4e    dec     regd: in: f=%x ESI=%x out: f=%x ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4e    dec     regw: in: f=%x SI=%x out: f=%x SI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x04f: 
         #define opcode 79
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD rF, r1, wF, w1;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  U_OP_DWORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4f    dec     regd: in: f=%x EDI=%x out: f=%x EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r1, w1;
                  DWORD rF, wF;
                  rF = READ_DWORD_FLAGS (env);
                  r1 = READ_WORD_REG (env, opcode & 7);
                  U_OP_WORD (dec, r1, w1, wF);
                  MOVE_FLAGS_OSZAP (wF, rF);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  4f    dec     regw: in: f=%x DI=%x out: f=%x DI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,rF,
                              r1,wF, w1);
                  
                  WRITE_DWORD_FLAGS (env, wF);
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x050: 
         #define opcode 80
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  50   push     regd: in: EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  50   push     regw: in: AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x051: 
         #define opcode 81
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  51   push     regd: in: ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  51   push     regw: in: CX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x052: 
         #define opcode 82
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  52   push     regd: in: EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  52   push     regw: in: DX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x053: 
         #define opcode 83
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  53   push     regd: in: EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  53   push     regw: in: BX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x054: 
         #define opcode 84
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  54   push     regd: in: ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  54   push     regw: in: SP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x055: 
         #define opcode 85
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  55   push     regd: in: EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  55   push     regw: in: BP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x056: 
         #define opcode 86
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  56   push     regd: in: ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  56   push     regw: in: SI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x057: 
         #define opcode 87
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  PUSH_DWORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  57   push     regd: in: EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              else {
                  WORD r1;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  PUSH_WORD (env, r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  57   push     regw: in: DI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x058: 
         #define opcode 88
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  58    pop     regd: out: EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  58    pop     regw: out: AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x059: 
         #define opcode 89
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  59    pop     regd: out: ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  59    pop     regw: out: CX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05a: 
         #define opcode 90
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5a    pop     regd: out: EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5a    pop     regw: out: DX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05b: 
         #define opcode 91
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5b    pop     regd: out: EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5b    pop     regw: out: BX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05c: 
         #define opcode 92
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5c    pop     regd: out: ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5c    pop     regw: out: SP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05d: 
         #define opcode 93
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5d    pop     regd: out: EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5d    pop     regw: out: BP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05e: 
         #define opcode 94
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5e    pop     regd: out: ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5e    pop     regw: out: SI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x05f: 
         #define opcode 95
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD w1;
                  w1 = POP_DWORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5f    pop     regd: out: EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD w1;
                  w1 = POP_WORD (env);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  5f    pop     regw: out: DI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x060: C1 (pusha); break;
         case 0x061: C1 (popa); break;
         case 0x062: C1 (boundGvMa); break;
         case 0x063: C1 (arplEwRw); break;
         case 0x068: C1 (pushIv); break;
         case 0x069: C1 (imulGvEvIv); break;
         case 0x06a: C1 (pushIb); break;
         case 0x06b: C1 (imulGvEvIb); break;
         case 0x06c: C1 (insXb); break;
         case 0x06d: C1 (insXv); break;
         case 0x06e: C1 (outsYb); break;
         case 0x06f: C1 (outsYv); break;
         case 0x070: cc = READ_DWORD_FLAGS (env);cc = (cc & OF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  70    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  70    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x071: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & OF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  71    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  71    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x072: cc = READ_DWORD_FLAGS (env);cc = (cc & CF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  72    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  72    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x073: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & CF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  73    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  73    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x074: cc = READ_DWORD_FLAGS (env);cc = (cc & ZF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  74    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  74    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x075: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  75    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  75    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x076: cc = READ_DWORD_FLAGS (env);cc = (cc & (CF | ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  76    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  76    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x077: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == (cc & (CF | ZF)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  77    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  77    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x078: cc = READ_DWORD_FLAGS (env);cc = (cc & SF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  78    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  78    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x079: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & SF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  79    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  79    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07a: cc = READ_DWORD_FLAGS (env);cc = (cc & PF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7a    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7a    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07b: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & PF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7b    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7b    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07c: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7c    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7c    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07d: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7d    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7d    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07e: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7e    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7e    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x07f: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7f    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SBYTE r1;
                 
                 r1 = (SBYTE) FETCH_BYTE (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x  7f    jcc       Jb: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x080: C1 (group_0); break;
         case 0x081: C1 (group_1); break;
         case 0x083: C1 (group_2); break;
         case 0x084: C1 (testEbGb); break;
         case 0x085: C1 (testEvGv); break;
         case 0x086: C1 (xchgEbGb); break;
         case 0x087: C1 (xchgEvGv); break;
         case 0x088: C1 (movEbGb); break;
         case 0x089: C1 (movEvGv); break;
         case 0x08a: C1 (movGbEb); break;
         case 0x08b: C1 (movGvEv); break;
         case 0x08c: C1 (movEvSw); break;
         case 0x08d: C1 (leaGvM); break;
         case 0x08e: C1 (movSwEv); break;
         case 0x08f: C1 (popEv); break;
         case 0x090: C1 (nop); break;
         case 0x091: 
         #define opcode 145
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  91   xchg regd,EAX: in: ECX=%x EAX=%x out: ECX=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  91   xchg  regw,AX: in: CX=%x AX=%x out: CX=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x092: 
         #define opcode 146
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  92   xchg regd,EAX: in: EDX=%x EAX=%x out: EDX=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  92   xchg  regw,AX: in: DX=%x AX=%x out: DX=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x093: 
         #define opcode 147
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  93   xchg regd,EAX: in: EBX=%x EAX=%x out: EBX=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  93   xchg  regw,AX: in: BX=%x AX=%x out: BX=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x094: 
         #define opcode 148
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  94   xchg regd,EAX: in: ESP=%x EAX=%x out: ESP=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  94   xchg  regw,AX: in: SP=%x AX=%x out: SP=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x095: 
         #define opcode 149
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  95   xchg regd,EAX: in: EBP=%x EAX=%x out: EBP=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  95   xchg  regw,AX: in: BP=%x AX=%x out: BP=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x096: 
         #define opcode 150
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  96   xchg regd,EAX: in: ESI=%x EAX=%x out: ESI=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  96   xchg  regw,AX: in: SI=%x AX=%x out: SI=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x097: 
         #define opcode 151
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, r2, w1, w2;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  r2 = READ_DWORD_REG (env, _REG_EAX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  97   xchg regd,EAX: in: EDI=%x EAX=%x out: EDI=%x EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
                  WRITE_DWORD_REG (env, _REG_EAX, w2);
              }
              else {
                  WORD r1, r2, w1, w2;
                  r1 = READ_WORD_REG (env, opcode & 7);
                  r2 = READ_WORD_REG (env, _REG_AX);
                  w1 = r2;
                  w2 = r1;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  97   xchg  regw,AX: in: DI=%x AX=%x out: DI=%x AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              r2,w1, w2);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
                  WRITE_WORD_REG (env, _REG_AX, w2);
              }
              break;
         }
         #undef opcode
         
         case 0x098: C1 (cbw); break;
         case 0x099: C1 (cwd); break;
         case 0x09a: C1 (callAp); break;
         case 0x09b: C1 (wait); break;
         case 0x09c: C1 (pushfFv); break;
         case 0x09d: C1 (popfFv); break;
         case 0x09e: C1 (sahf); break;
         case 0x09f: C1 (lahf); break;
         case 0x0a0: C1 (movALOb); break;
         case 0x0a1: C1 (moveAXOv); break;
         case 0x0a2: C1 (movObAL); break;
         case 0x0a3: C1 (movOveAX); break;
         case 0x0a4: C1 (movsXbYb); break;
         case 0x0a5: C1 (movsXvYv); break;
         case 0x0a6: C1 (cmpsXbYb); break;
         case 0x0a7: C1 (cmpsXvYv); break;
         case 0x0a8: C1 (testALIb); break;
         case 0x0a9: C1 (testeAXIv); break;
         case 0x0aa: C1 (stosYb); break;
         case 0x0ab: C1 (stosYv); break;
         case 0x0ac: C1 (lodsXb); break;
         case 0x0ad: C1 (lodsXv); break;
         case 0x0ae: C1 (scasYb); break;
         case 0x0af: C1 (scasYv); break;
         case 0x0b0: 
         #define opcode 176
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b0    mov  regb,Ib: in: imm=%x out: AL=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b1: 
         #define opcode 177
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b1    mov  regb,Ib: in: imm=%x out: CL=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b2: 
         #define opcode 178
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b2    mov  regb,Ib: in: imm=%x out: DL=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b3: 
         #define opcode 179
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b3    mov  regb,Ib: in: imm=%x out: BL=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b4: 
         #define opcode 180
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b4    mov  regb,Ib: in: imm=%x out: AH=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b5: 
         #define opcode 181
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b5    mov  regb,Ib: in: imm=%x out: CH=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b6: 
         #define opcode 182
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b6    mov  regb,Ib: in: imm=%x out: DH=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b7: 
         #define opcode 183
         
         {
              BYTE r2, w1;
              
              r2 = FETCH_BYTE (env);
              w1 = r2;
              if (NULL != turtle_log)
                  fprintf (turtle_log, "%08x  b7    mov  regb,Ib: in: imm=%x out: BH=%x\n",
                          (DWORD) env->segs[_SEG_CS].base + env->eip,r2,w1);
              
              WRITE_BYTE_REG (env, opcode & 7, w1);
              break;
         }
         #undef opcode
         
         case 0x0b8: 
         #define opcode 184
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  b8    mov  regd,Id: in: imm=%x out: EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  b8    mov  regw,Iw: in: imm=%x out: AX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0b9: 
         #define opcode 185
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  b9    mov  regd,Id: in: imm=%x out: ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  b9    mov  regw,Iw: in: imm=%x out: CX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0ba: 
         #define opcode 186
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  ba    mov  regd,Id: in: imm=%x out: EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  ba    mov  regw,Iw: in: imm=%x out: DX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0bb: 
         #define opcode 187
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bb    mov  regd,Id: in: imm=%x out: EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bb    mov  regw,Iw: in: imm=%x out: BX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0bc: 
         #define opcode 188
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bc    mov  regd,Id: in: imm=%x out: ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bc    mov  regw,Iw: in: imm=%x out: SP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0bd: 
         #define opcode 189
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bd    mov  regd,Id: in: imm=%x out: EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bd    mov  regw,Iw: in: imm=%x out: BP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0be: 
         #define opcode 190
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  be    mov  regd,Id: in: imm=%x out: ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  be    mov  regw,Iw: in: imm=%x out: SI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0bf: 
         #define opcode 191
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r2, w1;
                  
                  r2 = FETCH_DWORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bf    mov  regd,Id: in: imm=%x out: EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                  WORD r2, w1;
                  
                  r2 = FETCH_WORD (env);
                  w1 = r2;
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x  bf    mov  regw,Iw: in: imm=%x out: DI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r2,
                              w1);
                  
                  WRITE_WORD_REG (env, opcode & 7, w1);
              }
              break;
         }
         #undef opcode
         
         case 0x0c0: C1 (group_3); break;
         case 0x0c1: C1 (group_4); break;
         case 0x0c2: C1 (retIw); break;
         case 0x0c3: C1 (ret); break;
         case 0x0c4: C1 (lesGvMp); break;
         case 0x0c5: C1 (ldsGvMp); break;
         case 0x0c6: C1 (movEbIb); break;
         case 0x0c7: C1 (movEvIv); break;
         case 0x0c8: C1 (enterIwIb); break;
         case 0x0c9: C1 (leave); break;
         case 0x0ca: C1 (retfIw); break;
         case 0x0cb: C1 (retf); break;
         case 0x0cc: C1 (int3); break;
         case 0x0cd: C1 (intIb); break;
         case 0x0ce: C1 (into); break;
         case 0x0cf: C1 (iret); break;
         case 0x0d0: C1 (group_5); break;
         case 0x0d1: C1 (group_6); break;
         case 0x0d2: C1 (group_7); break;
         case 0x0d3: C1 (group_8); break;
         case 0x0d4: C1 (aamIb); break;
         case 0x0d5: C1 (aadIb); break;
         case 0x0d6: C1 (salc); break;
         case 0x0d7: C1 (xlat); break;
         case 0x0e0: C1 (loopneJb); break;
         case 0x0e1: C1 (loopeJb); break;
         case 0x0e2: C1 (loopJb); break;
         case 0x0e3: C1 (jcxzJb); break;
         case 0x0e4: C1 (inALIb); break;
         case 0x0e5: C1 (ineAXIb); break;
         case 0x0e6: C1 (outIbAL); break;
         case 0x0e7: C1 (outIbeAX); break;
         case 0x0e8: C1 (callJv); break;
         case 0x0e9: C1 (jmpJv); break;
         case 0x0ea: C1 (jmpAp); break;
         case 0x0eb: C1 (jmpJb); break;
         case 0x0ec: C1 (inALDX); break;
         case 0x0ed: C1 (ineAXDX); break;
         case 0x0ee: C1 (outDXAL); break;
         case 0x0ef: C1 (outDXeAX); break;
         case 0x0f1: C1 (icebp); break;
         case 0x0f4: C1 (hlt); break;
         case 0x0f5: C1 (cmc); break;
         case 0x0f6: C1 (group_9); break;
         case 0x0f7: C1 (group_10); break;
         case 0x0f8: C1 (clc); break;
         case 0x0f9: C1 (stc); break;
         case 0x0fa: C1 (cli); break;
         case 0x0fb: C1 (sti); break;
         case 0x0fc: C1 (cld); break;
         case 0x0fd: C1 (std); break;
         case 0x0fe: C1 (group_11); break;
         case 0x0ff: C1 (group_12); break;
         case 0x100: C1 (group_13); break;
         case 0x102: C1 (larGvEw); break;
         case 0x103: C1 (lslGvEw); break;
         case 0x120: C1 (movRdCd); break;
         case 0x121: C1 (movRdDd); break;
         case 0x122: C1 (movCdRd); break;
         case 0x123: C1 (movDdRd); break;
         case 0x124: C1 (movRdTd); break;
         case 0x126: C1 (movTdRd); break;
         case 0x140: cc = READ_DWORD_FLAGS (env);cc = (cc & OF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 140 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 140 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x141: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & OF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 141 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 141 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x142: cc = READ_DWORD_FLAGS (env);cc = (cc & CF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 142 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 142 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x143: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & CF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 143 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 143 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x144: cc = READ_DWORD_FLAGS (env);cc = (cc & ZF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 144 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 144 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x145: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 145 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 145 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x146: cc = READ_DWORD_FLAGS (env);cc = (cc & (CF | ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 146 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 146 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x147: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == (cc & (CF | ZF)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 147 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 147 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x148: cc = READ_DWORD_FLAGS (env);cc = (cc & SF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 148 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 148 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x149: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & SF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 149 cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 149 cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14a: cc = READ_DWORD_FLAGS (env);cc = (cc & PF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14a cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14a cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14b: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & PF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14b cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14b cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14c: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14c cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14c cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14d: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14d cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14d cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14e: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14e cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14e cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x14f: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 BYTE modrm;
                 DWORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_DWORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_DWORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_DWORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14f cmovcc    Gd,Ed: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_DWORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             else {
                 BYTE modrm;
                 WORD r1, r2, w1;
                 modrm = FETCH_BYTE (env);
                 r1 = READ_WORD_REG (env, GET_MODRM_REG (modrm));
                 if (IS_MODRM_MEM (modrm)) {
                     DWORD rm;
                     rm = LEA (env, modrm);
                     r2 = READ_WORD_MEM (env, rm);
                 }
                 else {
                     DWORD rm;
                     rm = GET_MODRM_RM (modrm);
                     r2 = READ_WORD_REG (env, rm);
                 }
                 if (cc) w1 = r2; else w1 = r1;
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 14f cmovcc    Gw,Ew: in: gx[%d]=%x r/m=%x out: gx[%d]=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,
                             GET_MODRM_REG (modrm), r1, r2,
                             GET_MODRM_REG (modrm), w1);
                 
                 WRITE_WORD_REG (env, GET_MODRM_REG (modrm), w1);
             }
             break;
         }
         case 0x180: cc = READ_DWORD_FLAGS (env);cc = (cc & OF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 180    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 180    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x181: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & OF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 181    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 181    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x182: cc = READ_DWORD_FLAGS (env);cc = (cc & CF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 182    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 182    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x183: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & CF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 183    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 183    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x184: cc = READ_DWORD_FLAGS (env);cc = (cc & ZF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 184    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 184    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x185: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 185    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 185    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x186: cc = READ_DWORD_FLAGS (env);cc = (cc & (CF | ZF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 186    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 186    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x187: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == (cc & (CF | ZF)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 187    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 187    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x188: cc = READ_DWORD_FLAGS (env);cc = (cc & SF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 188    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 188    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x189: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & SF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 189    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 189    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18a: cc = READ_DWORD_FLAGS (env);cc = (cc & PF);
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18a    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18a    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18b: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & PF));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18b    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18b    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18c: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18c    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18c    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18d: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18d    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18d    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18e: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18e    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18e    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x18f: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)))));
         {
             if (IS_OPERAND_SIZE_32 (env)) {
                 SDWORD r1;
                 
                 r1 = (SDWORD) FETCH_DWORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_DWORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18f    jcc       Jd: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             else {
                 SWORD r1;
                 
                 r1 = (SWORD) FETCH_WORD (env);
                 if (cc) {
                     JUMP_NEAR_RELATIVE_WORD (env, r1);
                 }
                 if (NULL != turtle_log)
                     fprintf (turtle_log, "%08x 18f    jcc       Jw: in: rel=%x\n",
                             (DWORD) env->segs[_SEG_CS].base + env->eip,r1);
                 
             }
             break;
         }
         case 0x190: cc = READ_DWORD_FLAGS (env);cc = (cc & OF);
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 190  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x191: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & OF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 191  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x192: cc = READ_DWORD_FLAGS (env);cc = (cc & CF);
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 192  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x193: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & CF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 193  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x194: cc = READ_DWORD_FLAGS (env);cc = (cc & ZF);
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 194  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x195: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & ZF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 195  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x196: cc = READ_DWORD_FLAGS (env);cc = (cc & (CF | ZF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 196  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x197: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == (cc & (CF | ZF)));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 197  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x198: cc = READ_DWORD_FLAGS (env);cc = (cc & SF);
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 198  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x199: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & SF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 199  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19a: cc = READ_DWORD_FLAGS (env);cc = (cc & PF);
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19a  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19b: cc = READ_DWORD_FLAGS (env);cc = (0 == (cc & PF));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19b  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19c: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19c  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19d: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19d  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19e: cc = READ_DWORD_FLAGS (env);
                     cc = ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT))));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19e  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x19f: cc = READ_DWORD_FLAGS (env);
                     cc = (0 == ((cc & ZF) | ((cc & SF) ^ ((cc & OF) >> (OF_SHIFT - SF_SHIFT)))));
         {
             BYTE w1, modrm;
             modrm = FETCH_BYTE (env);
             w1 = 0 != cc;
             if (NULL != turtle_log)
                 fprintf (turtle_log, "%08x 19f  setcc       Eb: out: r/m=%x\n",
                         (DWORD) env->segs[_SEG_CS].base + env->eip,w1);
             
             if (IS_MODRM_MEM (modrm)) {
                 DWORD rm;
                 rm = LEA (env, modrm);
                 if (0 == (env->iflags & IF_CONFIRM))
                 WRITE_BYTE_MEM (env, rm, w1);
             }
             else {
                 DWORD rm;
                 rm = GET_MODRM_RM (modrm);
                 WRITE_BYTE_REG (env, rm, w1);
             }
             break;
         }
         case 0x1a0: C1 (pushFS); break;
         case 0x1a1: C1 (popFS); break;
         case 0x1a4: C1 (shldEvGvIb); break;
         case 0x1a5: C1 (shldEvGvCL); break;
         case 0x1a8: C1 (pushGS); break;
         case 0x1a9: C1 (popGS); break;
         case 0x1ac: C1 (shrdEvGvIb); break;
         case 0x1ad: C1 (shrdEvGvCL); break;
         case 0x1af: C1 (imulGvEv); break;
         case 0x1b0: C1 (cmpxchgEbGb); break;
         case 0x1b1: C1 (cmpxchgEvGv); break;
         case 0x1b2: C1 (lssGvMp); break;
         case 0x1b4: C1 (lfsGvMp); break;
         case 0x1b5: C1 (lgsGvMp); break;
         case 0x1b6: C1 (movzxGvEb); break;
         case 0x1b7: C1 (movzxGvEw); break;
         case 0x1be: C1 (movsxGvEb); break;
         case 0x1bf: C1 (movsxGvEw); break;
         case 0x1c8: 
         #define opcode 456
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1c8  bswap     regd: in: EAX=%x out: EAX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1c8  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1c9: 
         #define opcode 457
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1c9  bswap     regd: in: ECX=%x out: ECX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1c9  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1ca: 
         #define opcode 458
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1ca  bswap     regd: in: EDX=%x out: EDX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1ca  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1cb: 
         #define opcode 459
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cb  bswap     regd: in: EBX=%x out: EBX=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cb  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1cc: 
         #define opcode 460
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cc  bswap     regd: in: ESP=%x out: ESP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cc  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1cd: 
         #define opcode 461
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cd  bswap     regd: in: EBP=%x out: EBP=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cd  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1ce: 
         #define opcode 462
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1ce  bswap     regd: in: ESI=%x out: ESI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1ce  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         case 0x1cf: 
         #define opcode 463
         
         {
              if (IS_OPERAND_SIZE_32 (env)) {
                  DWORD r1, w1;
                  r1 = READ_DWORD_REG (env, opcode & 7);
                  w1 = bswap_32 (r1);
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cf  bswap     regd: in: EDI=%x out: EDI=%x\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip,r1,
                              w1);
                  
                  WRITE_DWORD_REG (env, opcode & 7, w1);
              }
              else {
                                              /* undefined */
                  if (NULL != turtle_log)
                      fprintf (turtle_log, "%08x 1cf  bswap     regw:\n",
                              (DWORD) env->segs[_SEG_CS].base + env->eip);
                  
              }
              break;
         }
         #undef opcode
         
         default: NOT_IMPLEMENTED (env); return;
     }
     #ifdef __GNUC__
       env = (X86 *) save;
     #endif
}
